#include <amxmodx>
#include <amxmisc>
#include <engine>
#include <fun>
#include <reapi>
#include <fakemeta>
#include <hamsandwich>
#include <sqlx>
//#include <gamecms5>
#include <nvault>

#define WCS_IMPULSE_OFFSET          128381

#pragma dynamic                     65536
#define WCS_MAX_ENTITIES            (1365 - 121 - 32)
#define WCS_MAX_WEAPONS             128
#define WCS_MAX_MENU_LINE           256
#define WCS_MAX_ADV_LIMITS          512
#define WCS_MAX_LIMITS              512
#define WCS_MAX_FILTERS             512
#define ACS_MAX_FLAG_CHARS          26
#define ACS_MAX_BUFFER_SIZE         256
#define ACS_MAX_NAME_LENGTH         32
#define ACS_MAX_NAME_ML_LENGTH      64
#define ACS_MAX_INT_STR_LENGTH      12
#define ACS_WEAPON_ALL_KEY          "*"
#define ACS_WCS_ITEM_PREFIX         "item_"
#define ACS_WCS_WEAPON_PREFIX       "weapon_"
#define SELF_ITEM_ADD               true
#define _ITEM_PREFIX(%0)            %0, ACS_WCS_ITEM_PREFIX
#define _ITEM_VALUE(%0)             %0[5]           
#define _WEAPON_PREFIX(%0)          %0, ACS_WCS_WEAPON_PREFIX
#define _WEAPON_VALUE(%0)           %0[7]
#define _SC(%0)                     %0, charsmax(%0)
#define _SS(%0)                     %0, sizeof(%0)
#define _SL(%0)                     %0, %0_len
#define _SF(%0)                     add_menu_reason(id, %0, i_reason, _SC(params[ALP_REASON]), INTERVAL_ROUNDS)
#define _SF2(%0)                    add_menu_reason(id, %0, i_reason, _SC(params[ALP_REASON]), INTERVAL_TIME)
#define _SF3(%0)                    add_menu_reason(id, %0, i_reason, _SC(params[ALP_REASON]), INTERVAL_NORMAL)

#define _SFF(%0)                    add_menu_reason2(%0, i_reason, f_data, INTERVAL_ROUNDS)
#define _SFF2(%0)                   add_menu_reason2(%0, i_reason, f_data, INTERVAL_TIME)
#define _SFF3(%0)                   add_menu_reason2(%0, i_reason, f_data, INTERVAL_NORMAL)

#define _DI(%0,%1)                  %1, fmt("%L", id, fmt("%s_SUFFIX_%d", %0, (0 <= %1 <= 10 || %1 >= 20 ? %1 % 10 : 0)))

#define _DII(%0,%1)                 %1, fmt("%L", f_data[ACS_FT_ID], fmt("%s_SUFFIX_%d", %0, (0 <= %1 <= 10 || %1 >= 20 ? %1 % 10 : 0)))

#define _DC(%0)                     gv_damager_colors[%0][0], gv_damager_colors[%0][1], gv_damager_colors[%0][2]
#define _DP(%0)                     gv_damager_coords[%0][0], gv_damager_coords[%0][1]
#define _BYTE(%0)                   ((%0) & 0xFF)
#define _WORD(%0)                   ((%0) & 0xFFFF)
#define _DW_BYTE(%0,%1)             (((%0) & (0xFF << (8 * (%1)))) >> (8 * (%1)))
#define ACS_SOUND_NOTIFY	        "buttons/bell1.wav"
#define ACS_SOUND_REJECT            "buttons/button2.wav"
#define ACS_SPRITE_LAZER            "sprites/laserbeam.spr"

#define var_weaponkey               var_iuser4
#define var_modelview               var_noise1
#define var_modelworld              var_message
#define var_modelplayer             var_noise2
#define var_weapontrace             var_iuser2
#define var_weaponflags             var_iuser1
#define var_weaponflags2            var_iuser3
#define var_customweapon            var_impulse
#define var_weaponfrecoil           var_fuser1

#define get_ms(%0)                  get_entvar(%0, var_maxspeed)
#define get_wk(%0)                  get_entvar(%0, var_weaponkey)
#define get_wt(%0)                  get_entvar(%0, var_weapontrace)
#define get_wf(%0)                  get_entvar(%0, var_weaponflags)
#define get_wf2(%0)                 get_entvar(%0, var_weaponflags2)
#define get_wr(%0)                  get_entvar(%0, var_weaponfrecoil)
#define get_cw(%0)                  get_entvar(%0, var_customweapon)
#define get_wmv(%0,%1)              get_entvar(%0, var_modelview, _SC(%1))
#define get_wmw(%0,%1)              get_entvar(%0, var_modelworld, _SC(%1))
#define get_wmp(%0,%1)              get_entvar(%0, var_modelplayer, _SC(%1))

#define set_ms(%0,%1)               set_entvar(%0, var_maxspeed, %1)
#define set_wk(%0,%1)               set_entvar(%0, var_weaponkey, %1)
#define set_wt(%0,%1)               set_entvar(%0, var_weapontrace, %1)
#define set_wf(%0,%1)               set_entvar(%0, var_weaponflags, %1)
#define set_wf2(%0,%1)              set_entvar(%0, var_weaponflags2, %1)
#define set_wr(%0,%1)               set_entvar(%0, var_weaponfrecoil, %1)
#define set_cw(%0,%1)               set_entvar(%0, var_customweapon, %1)
#define set_wmv(%0,%1)              set_entvar(%0, var_modelview, %1)
#define set_wmw(%0,%1)              set_entvar(%0, var_modelworld, %1)
#define set_wmp(%0,%1)              set_entvar(%0, var_modelplayer, %1)

//#define is_valid_player(%0)		    bool:is_user_connected(%0)
#define is_valid_player(%0)         (0 < %0 < MAX_PLAYERS + 1 && get_bit(gi_client_connected, %0))
#define is_valid_team(%0)           (TEAM_TERRORIST <= (tm_player = get_member(%0, m_iTeam)) <= TEAM_CT)
#define is_custom_weapon(%0)        check_custom_weapon(%0, get_wk(%0))
#define is_purchase                 (cmd_type == CMD_PLAYER)
#define check_flags(%0,%1)          (%0 < 0 ? ((~%0 & %1) ^ (~%0)) : (%0 & %1))
#define acs_str_to_num(%0)          (%0[0] == '-' ? (-1) * str_to_num(%0[1]) : str_to_num(%0))
#define is_entity_max_count()       (entity_count() >= WCS_MAX_ENTITIES)
#define get_wb(%0)                  _get_weapon_box(%0)
#define WP_KEY(%0)                  fmt("index_%u", %0)
#define is_comment_line(%0)         (%0[0] == 0 || %0[0] == 10 || %0[0] == 13 || %0[0] == ';' || %0[0] == '#' || (%0[0] == '/' && %0[1] == '/'))
#define is_menu_line(%0)            (%0[0] == ';' && %0[1] == '@')
#define is_adv_limit_line(%0)       (%0[0] == ';' && %0[1] == '#')
#define is_task_line(%0)            (%0[0] == ';' && %0[1] == '$')
#define is_event_line(%0)           (%0[0] == ';' && %0[1] == '%')
#define pickup_blocked(%0,%1)       (!is_nullent(%0) && is_valid_player(%1) && is_custom_weapon(%0) && get_wf2(%0) && !(get_user_flags(%1) & get_wf2(%0)))
#define rg_get_user_money(%0)       get_member(%0, m_iAccount)
#define get_bit(%1,%2)              (%1 & (1 << (%2 & 31)))
#define set_bit(%1,%2)              (%1 |= (1 << (%2 & 31)))
#define reset_bit(%1,%2)            %1 &= ~(1 << (%2 & 31))

#define ACS_SOUND_MASK          (~(1+16+32+64+128+512))   // Какие сообщения выводить без звукового сопровождения и контроля троттлинга

enum _:ACS_NOTIFY_MODE {
    ACS_SHOW_DEBUG              = 0,
    ACS_SHOW_SILIENT            = 1,    // Без звука, без лимита
    ACS_SHOW_GET                = 2,    // Сопровождается звуком NOTIFY
    ACS_SHOW_BUY                = 4,	// Сопровождается звуком NOTIFY
    ACS_SHOW_NO_ACCESS          = 8,	// Сопровождается звуком REJECT
    ACS_SHOW_NO_ACCESS2         = 16,   // Без звука
    ACS_SHOW_ROUNDS             = 32,   // Без звука
    ACS_SHOW_BUYTIME            = 64,   // Без звука
    ACS_SHOW_NOT_IN_BUYZONE     = 128,  // Без звука
    ACS_SHOW_NO_MONEY           = 256,  // Сопровождается звуком REJECT
    ACS_SHOW_BLINK              = 512,  // Без звука
    ACS_SHOW_LIMIT_PLAYER       = 1024, // Сопровождается звуком REJECT
    ACS_SHOW_LIMIT_TEAM         = 2048, // Сопровождается звуком REJECT
    ACS_SHOW_LIMIT_TOTAL        = 4096  // Сопровождается звуком REJECT
}

enum _:ACS_STOP_THROTTLING {
    bool:FLAG,
    Float:LAST_USAGE
}

enum _:ACS_WCS_CVARS {
    PREFIX[ACS_MAX_NAME_LENGTH / 2],
	Float: BUYTIME,
	BUYZONE,
    DISCOUNT,
	CMD_ACCESS[ACS_MAX_FLAG_CHARS],
	GIVE_TYPE,
	PICKUP_ACCESS_TYPE,
	TRACE_TYPE,
    NOTIFY_MODE,
    NOTIFY_SOUND_MODE,
    DIFF_MODE,
    AES_PLUGIN[ACS_MAX_NAME_LENGTH],
    RESTORE_MAXSPEED,
    VIPMENU_ROUND,
    VIPMENU_TIMEOUT,
    VIPMENU_MODE,
    MAX_MONEY,
    MAX_HP,
    MAX_ARMOR,
    MAX_AMMO,
    MAX_SPEED,
    ROUND_CONTROL,
    SERVER_NAME[ACS_MAX_NAME_ML_LENGTH],
    GAMECMS_ENABLE,
    GAMECMS_DB_HOST[ACS_MAX_NAME_LENGTH],
    GAMECMS_DB_NAME[ACS_MAX_NAME_LENGTH],
    GAMECMS_DB_USER[ACS_MAX_NAME_LENGTH],
    GAMECMS_DB_PASS[ACS_MAX_NAME_LENGTH],
    LOG
}

enum _:ACS_WCS_MENU {
    MENU_NAME[ACS_MAX_NAME_ML_LENGTH],
    MENU_ACCESS_FLAGS,
    MENU_ALLOW_ROUND,
    MENU_ITEMS[ACS_MAX_BUFFER_SIZE],
    MENU_CLCMDS[ACS_MAX_NAME_ML_LENGTH],
    MENU_NATIVE[2 * ACS_MAX_NAME_ML_LENGTH]
}

enum _:ACS_WCS {
	WCS_WEAPON_REFERENCE[ACS_MAX_NAME_LENGTH],
	WeaponIdType:WCS_WEAPON_ID,
	InventorySlotType:WCS_WEAPON_SLOT,
	WCS_NAME_ITEM[ACS_MAX_NAME_ML_LENGTH],
    WCS_CL_CMDS[ACS_MAX_NAME_LENGTH],
	WCS_COST,
	WCS_AMMO,
	WCS_BP_AMMO,
	Float: WCS_DAMAGE,
	Float: WCS_RECOIL,
    WCS_MAXSPEED[ACS_MAX_INT_STR_LENGTH],
	WCS_TRACE,
	WCS_MENU_ADD,
	WCS_ACCESS_FLAGS,
	WCS_PICKUP_FLAGS,
	WCS_MODEL_VIEW[MAX_RESOURCE_PATH_LENGTH],
	WCS_MODEL_PLAYER[MAX_RESOURCE_PATH_LENGTH],
	WCS_MODEL_WORLD[MAX_RESOURCE_PATH_LENGTH]
}

enum _:ACS_WCS_SECONDARY {
    WCS_SEC_CL_CMDS[ACS_MAX_NAME_LENGTH],
}

enum _:ACS_WCS_CFG {
    cfg_delay[ACS_MAX_INT_STR_LENGTH / 3],
    cfg_type[ACS_MAX_INT_STR_LENGTH / 4],
    cfg_time[ACS_MAX_INT_STR_LENGTH],
    cfg_domination[ACS_MAX_INT_STR_LENGTH / 4],
    cfg_players_count[ACS_MAX_INT_STR_LENGTH / 2],
    cfg_cost[ACS_MAX_INT_STR_LENGTH / 2],
    cfg_exp[ACS_MAX_INT_STR_LENGTH / 2],
    cfg_ammo[ACS_MAX_INT_STR_LENGTH / 3],
    cfg_bp_ammo[ACS_MAX_INT_STR_LENGTH / 3],
    cfg_damage[ACS_MAX_INT_STR_LENGTH / 2],
    cfg_recoil[ACS_MAX_INT_STR_LENGTH / 2],
    cfg_allow_round[ACS_MAX_INT_STR_LENGTH / 2],
    cfg_limit[ACS_MAX_INT_STR_LENGTH / 3],
    cfg_limit_team[ACS_MAX_INT_STR_LENGTH / 3],
    cfg_limit_total[ACS_MAX_INT_STR_LENGTH / 3],
    cfg_trace[ACS_MAX_INT_STR_LENGTH / 4],
    cfg_menu_add[ACS_MAX_INT_STR_LENGTH / 4],
    cfg_access_flag[ACS_MAX_FLAG_CHARS],
    cfg_pickup_flag[ACS_MAX_FLAG_CHARS],
    cfg_items[ACS_MAX_BUFFER_SIZE]
}

enum _:ACS_WCS_LIMITS {
    HANDED_TEAM[2],
    HANDED_TOTAL,
    HANDED_PLAYER[MAX_PLAYERS + 1]
}

enum _:ACS_WCS_ADV_LIMITS {
    WCS_LIMIT_ID[WCS_MAX_ADV_LIMITS],
    WCS_LIMIT_COUNT
}

enum _:ACS_WCS_TASK_DATA {
    TASK_NAME[ACS_MAX_NAME_ML_LENGTH],
    TASK_TYPE,
    TASK_ACCESS_FLAG,
    TASK_ALLOW_ROUNDS,
    TASK_DELAY,
    TASK_TIME,
    TASK_PLAYERS_COUNT,
    TASK_EXP,
    TASK_DOMINATION,
    TASK_ITEMS[ACS_MAX_BUFFER_SIZE],
    TASK_CL_CMDS[ACS_MAX_BUFFER_SIZE],
    TASK_SV_CMDS[ACS_MAX_BUFFER_SIZE],
    TASK_NATIVE[2 * ACS_MAX_NAME_ML_LENGTH]
}

enum _:ACS_WCS_FILTER_TASK {
    ACS_FT_FILTER,
    ACS_FT_NAME[ACS_MAX_NAME_ML_LENGTH],
    ACS_FT_ID,
    ACS_FT_TYPE,
    ACS_FT_INDEX,
    TeamName:ACS_FT_TM_PLAYER,
    TeamName:ACS_FT_TM_DOMINATE,
    ACS_FT_TM_DIFF,
    ACS_FT_HANDED_PLAYER,
    ACS_FT_HANDED_TEAM,
    ACS_FT_HANDED_TOTAL,
    ACS_FT_ITEMS[ACS_MAX_BUFFER_SIZE],
    ACS_FT_CL_CMDS[ACS_MAX_BUFFER_SIZE],
    ACS_FT_SV_CMDS[ACS_MAX_BUFFER_SIZE],
    ACS_FT_NATIVE[ACS_MAX_BUFFER_SIZE],
    bool:ACS_FT_GIVE_ITEMS,
    ACS_FT_ERROR[2 * ACS_MAX_NAME_ML_LENGTH],
    ACS_FT_REASON[ACS_MAX_BUFFER_SIZE],
    ACS_FT_SUFFIX[ACS_MAX_NAME_LENGTH],
    bool:ACS_FT_SHOW_ERROR
}

enum _:ACS_WCS_EVENT_TYPES {
    ACS_ET_ALL          = -1,
    ACS_ET_NONE         = 0,
    ACS_ET_KILL         = 1,
    ACS_ET_KILL_HS      = 2,
    ACS_ET_KILL_HE      = 4,
    ACS_ET_KILL_KNIFE   = 8,
    ACS_ET_KILL_BOMB    = 16,
}

enum _:ACS_WCS_ADV_LIMIT_PARAMS {
    ALP_ERROR[2 * ACS_MAX_NAME_ML_LENGTH],
    ALP_REASON[ACS_MAX_BUFFER_SIZE],
    ALP_SUFFIX[ACS_MAX_NAME_LENGTH],
    bool:ALP_SHOW_ERROR
}

enum _:ACS_WCS_ADV_FILTER_TYPES {
    WCS_ADV_LIMITS,
    WCS_ADV_TASKS,
    WCS_ADV_EVENTS
}

enum _:ACS_WCS_AVD_FILTERS {
    FILTER_NAME[ACS_MAX_NAME_ML_LENGTH],
    FILTER_TYPE,
    FILTER_ACCESS_FLAG,
    FILTER_MAPS[ACS_MAX_BUFFER_SIZE],
    FILTER_ALLOW_ROUNDS,
    Float:FILTER_DELAY,
    FILTER_TIME,
    FILTER_PLAYERS_COUNT,
    FILTER_EXP,
    FILTER_DOMINATION,
    FILTER_LIMIT,
    FILTER_LIMIT_TEAM,
    FILTER_LIMIT_TOTAL,
    FILTER_ITEMS[ACS_MAX_BUFFER_SIZE],
    FILTER_CL_CMDS[ACS_MAX_BUFFER_SIZE],
    FILTER_SV_CMDS[ACS_MAX_BUFFER_SIZE],
    FILTER_NATIVE[ACS_MAX_BUFFER_SIZE]
}

enum ACS_WCS_CMD_TYPES
{
	CMD_ADMIN,
	CMD_PLAYER,
	CMD_NATIVE,
	CMD_MENU
}

enum _:ACS_WCS_GIVE_TYPES {
	APPEND_SLOT,
	REMOVE_SLOT,
	DROP_SLOT
}

enum ACS_WCS_FORWARDS {
	FWD_ON_GIVE_ITEM_PRE,
	FWD_ON_PARSE_END
}

enum _:ACS_WCS_MENUS {
    MENU_BUY, MENU_BUY_1, MENU_BUY_2
}

enum _:ACS_WCS_ADD_SPEED {
    SPEED_VALUE,
    bool:SPEED_RELATIVE
}

enum _:ACS_WCS_TASKS {
    TASK_TIMER          = 100,
    TASK_PROCESS        = 200,
    TASK_MENU_TIMEOUT   = 300,
    TASK_EVENT          = 400,
    TASK_ADV_TASK       = 500,
}

enum _:ACS_TIMER_DATA {
    Float:TIMER_VALUE,
    TIMER_ID    
}

enum _:ACS_OFFLINE {
    NVLT_HANDLE,
    NVLT_NAME[32],
    bool:NVLT_LOADED
}

enum _:ACS_OFFLINE_CMDS {
    ACS_OFFLINE_INIT = 0,
    ACS_OFFLINE_RESET,
    ACS_OFFLINE_SET,
    ACS_OFFLINE_PSET,
    ACS_OFFLINE_GET
}

enum _:ACS_OFFLINE_SETS {
    ACS_NVLT_CORE = 0
}

enum _:ACS_WCS_INTERVAL_FORMATS {
    INTERVAL_NORMAL,
    INTERVAL_TIME,
    INTERVAL_ROUNDS
}

enum _:ACS_WCS_DAMAGER_DATA {
    Float:DMG_THRESHOLD,
    DMG_POS,
    DMG_TYPE,
    bool:DMG_ENABLED
}

enum _:ACS_WCS_GAMECMS {
    TIME_TRACKING_STOPPED = -3,
    TIME_MAP_END_EXPIRING,
    TIME_NOT_EXPIRING,
    TIME_SERVICE_NOT_FOUND
}

enum _:ACS_WCS_GAMECMS_DATA {
    GAMECMS_NAME[ACS_MAX_NAME_ML_LENGTH],
    GAMECMS_AUTHID[MAX_AUTHID_LENGTH],
    GAMECMS_TIMELEFT,
    GAMECMS_TIMELEFT_TEXT[ACS_MAX_NAME_ML_LENGTH],
    bool:GAMECMS_ACTIVE,
    bool:GAMECMS_PAUSED,
    bool:GAMECMS_LOADED
}

new const gv_damager_colors[][] = {
    {0, 187, 227},
    {0, 255, 0},
    {74, 200, 201},
    {198, 199, 0},
    {148, 0, 207},
    {0, 179, 0},
    {158, 42, 149},
    {209, 88, 0},
    {0, 199, 78},
    {35, 36, 179},
    {38, 199, 0},
    {80, 14, 184},
    {209, 141, 0},
    {217, 0, 0},
    {137, 199, 0},
    {0, 75, 194},
    {199, 0, 125},
    {118, 199, 67}
};

new const Float:gv_damager_coords[][] = {
    {0.60, -1.0},
    {0.58, 0.58},
    {-1.0, 0.60},
    {0.42, 0.58},
    {0.4, -1.0},
    /*
    {0.50, 0.40},
    {0.56, 0.44},
    {0.60, 0.50},
    {0.56, 0.56},
    {0.50, 0.60},
    {0.44, 0.56},
    {0.40, 0.50},
    {0.44, 0.44}
    */
};

new gh_lazer_beam;
new gi_weapon_count;
new CVAR[ACS_WCS_CVARS];
new Array:ga_weapon_data;
new Array:ga_weapon_limit;
new Array:ga_menu_data;
new Array:ga_adv_limits;
new Array:ga_filters[ACS_WCS_ADV_FILTER_TYPES];
new Trie:gt_weapon_owner;
new Trie:gt_weapon_limit;
new Trie:gt_adv_limit;
new Trie:gt_weapon_clcmd;
new Trie:gt_weapon_recoil;
new bool:is_recoil_module_loaded;
new Float:gf_touch_time[MAX_PLAYERS + 1];
new ACS_PRINT_THR[MAX_PLAYERS + 1][ACS_STOP_THROTTLING];
new gi_add_speed[MAX_PLAYERS + 1][ACS_WCS_ADD_SPEED];
new gi_total_rounds_played;
new ga_damager[MAX_PLAYERS + 1][ACS_WCS_DAMAGER_DATA];
new gh_hudsync[4], gh_hudsync_damager[4];
new gs_mapname[ACS_MAX_NAME_LENGTH];
new gb_round_infinite;
new gi_max_entities;
new Handle:gh_sql_tuple;
new ga_gamecms_data[MAX_PLAYERS + 1][ACS_WCS_GAMECMS_DATA];
new gs_hostname[ACS_MAX_NAME_LENGTH];
new gi_round_time;
new gh_nvault[ACS_OFFLINE_SETS][ACS_OFFLINE];
new gi_client_connected;

/*
enum _:ACS_WCS_MENU_DATA {
    D_FLAG[ACS_MAX_INT_STR_LENGTH], D_STEP[ACS_MAX_INT_STR_LENGTH], D_ITEMS[ACS_MAX_BUFFER_SIZE]
}
stock acs_parse_menu_params(const params[], arr[]) {
    static i_i, s_value[ACS_MAX_NAME_ML_LENGTH], s_tmp[ACS_MAX_BUFFER_SIZE];
    i_i = 0;
    copy(_SC(s_tmp), params);
    do {
        str(s_tmp, _SC(s_value), _SC(s_tmp), '#', 1);
    } while
}
*/

stock log_acs(const message[], any:...) {
    static _PLUGIN_NAME[ACS_MAX_NAME_LENGTH];
    static _LOGPATH[PLATFORM_MAX_PATH];
    static s_log_data[4 * ACS_MAX_BUFFER_SIZE];
    if (!_PLUGIN_NAME[0]) {
        get_plugin(-1, _PLUGIN_NAME, charsmax(_PLUGIN_NAME));
        replace(_PLUGIN_NAME, charsmax(_PLUGIN_NAME), ".amxx", "");
    }
    if (!_LOGPATH[0]) {
        get_localinfo("amxx_logs", _LOGPATH, charsmax(_LOGPATH));
        format(_LOGPATH, charsmax(_LOGPATH), "%s/%s.log", _LOGPATH, _PLUGIN_NAME);
    }
    vformat(s_log_data, charsmax(s_log_data), message, 2);
    acs_log_to_file(_LOGPATH, s_log_data);
}

stock acs_log_to_file(const filename[], const message[], const bool:is_buffered = false) {
    static _MOD_NAME[ACS_MAX_NAME_LENGTH];
    static _AMXX_VERSION[ACS_MAX_NAME_LENGTH];
    static h_file, bool:b_file_exists, s_date[ACS_MAX_NAME_LENGTH];
    if (filename[0] && message[0]) {
        if (!_MOD_NAME[0])
            get_modname(_MOD_NAME, charsmax(_MOD_NAME));
        if (!_AMXX_VERSION[0])
            get_amxx_verstring(_AMXX_VERSION, charsmax(_AMXX_VERSION));
        format_time(s_date, charsmax(s_date), "%m/%d/%Y - %H:%M:%S");
        b_file_exists = h_file ? true : bool:file_exists(filename);
        if (!h_file)
            h_file = fopen(filename, "at");
        if (h_file) {
            if (!b_file_exists)
                fprintf(h_file, "L %s: Log file started (file ^"%s^") (game ^"%s^") (amx ^"%s^")^n", s_date, filename, _MOD_NAME, _AMXX_VERSION);
            fprintf(h_file, "L %s: %s^n", s_date, message);
        } else
            log_error(AMX_ERR_GENERAL, "[ACS_WCS] ERROR: acs_log_to_file(), can't open file %s", filename);
    }
    if (h_file && !is_buffered) {
        fclose(h_file);
        h_file = 0;
    }
}

stock acs_send_audio(const id, sample[]) {
    static i_msg;
    if (sample[0]) {
        if ((id == 0) || is_user_connected(id)) {
            if (!i_msg) {
                i_msg = get_user_msgid("SendAudio");
            }
            message_begin(id ? MSG_ONE_UNRELIABLE : MSG_BROADCAST, i_msg, .player = id);
            {
                write_byte(id);
                write_string(sample);
                write_short(PITCH_NORM);
            }
            message_end();
        }
    }
}

stock acs_set_fail_state(const message[], any:...) {
    new s_tmp[ACS_MAX_BUFFER_SIZE];
    vformat(_SC(s_tmp), message, 2);
    log_acs(s_tmp);
    set_fail_state(s_tmp);
}

stock _get_weapon_box(entity)
{
    new i_i, i_weapon;
    for(i_i = 0; i_i < MAX_ITEM_TYPES; i_i++) {
        if(!is_nullent((i_weapon = get_member(entity, m_WeaponBox_rgpPlayerItems, i_i))))
            return i_weapon;
    }
    return NULLENT;
}

stock bool:rg_get_user_buyzone(const id)
{
    new i_signals[UnifiedSignals];
    get_member(id, m_signals, i_signals);
    return bool:(SignalState:i_signals[US_State] & SIGNAL_BUY);
}

stock acs_declension_time(const player, text[], const text_len, time, short_format = 0, round = 4) {
    // ГОСТ ГОСТ 8.417—2002
    new i_days, i_days_suffix, s_days_ml[ACS_MAX_NAME_LENGTH], i_hours, i_hours_suffix, s_hours_ml[ACS_MAX_NAME_LENGTH], i_minutes, minutes_suffix, s_minutes_ml[ACS_MAX_NAME_LENGTH], i_seconds, i_seconds_suffix, s_seconds_ml[ACS_MAX_NAME_LENGTH];
    i_days = time / 86400;                                                            
    if (i_days > 0)
        if (--round <= 0) {
            time = i_days * 86400;
            i_days++;
        }
    i_hours = (time - i_days * 86400) / 3600;                                            
    if (i_hours > 0)
        if (--round <= 0) {
            time = i_hours * 3600 + i_days * 86400;
            i_hours++;
        }
    i_minutes = (time - i_days * 86400 - i_hours * 3600) / 60;                             
    if (i_minutes > 0)
        if (--round <= 0) {
            time = i_minutes * 60 + i_hours * 3600 + i_days * 86400;
            i_minutes++;
        }
    if (i_minutes == 60) {
        i_minutes = 0;
        i_hours++;
    }
    if (i_hours == 24) {
        i_hours = 0;
        i_days++;
    }
    i_seconds = time - i_days * 86400 - i_hours * 3600 - i_minutes * 60;                     
    if (i_days / 10 == 1)
        i_days_suffix = 0;
    else
        i_days_suffix = i_days % 10;
    if (i_hours / 10 == 1)
        i_hours_suffix = 0;
    else
        i_hours_suffix = i_hours % 10;
    if (i_minutes / 10 == 1)
        minutes_suffix = 0;
    else
        minutes_suffix = i_minutes % 10;
    if (i_seconds / 10 == 1)
        i_seconds_suffix = 0;
    else
        i_seconds_suffix = i_seconds % 10;
    if (short_format) {
        s_days_ml = "ACS_DECLENSION_DAYS_SHORT";
        s_hours_ml = "ACS_DECLENSION_HOURS_SHORT";
        s_minutes_ml = "ACS_DECLENSION_MINUTES_SHORT";
        s_seconds_ml = "ACS_DECLENSION_SECONDS_SHORT";
    } else {       
        formatex(s_days_ml, charsmax(s_days_ml), "ACS_DECLENSION_DAYS_%d", i_days_suffix);
        formatex(s_hours_ml, charsmax(s_hours_ml), "ACS_DECLENSION_HOURS_%d", i_hours_suffix);
        formatex(s_minutes_ml, charsmax(s_minutes_ml), "ACS_DECLENSION_MINUTES_%d", minutes_suffix);
        formatex(s_seconds_ml, charsmax(s_seconds_ml), "ACS_DECLENSION_SECONDS_%d", i_seconds_suffix);
    }
    format(s_days_ml, charsmax(s_days_ml), "%L", player, s_days_ml, i_days);
    format(s_hours_ml, charsmax(s_hours_ml), "%L", player, s_hours_ml, i_hours);
    format(s_minutes_ml, charsmax(s_minutes_ml), "%L", player, s_minutes_ml, i_minutes);
    format(s_seconds_ml, charsmax(s_seconds_ml), "%L", player, s_seconds_ml, i_seconds);
    formatex(text, text_len, "");
    if (i_days > 0)
        formatex(text, text_len, "%s", s_days_ml);
    if (i_hours > 0)
        format(text, text_len, "%s %s", text, s_hours_ml);
    if (i_minutes > 0)
        format(text, text_len, "%s %s", text, s_minutes_ml);    
    if (i_seconds > 0 || (i_days == 0 && i_hours == 0 && i_minutes == 0 && i_seconds == 0))
        format(text, text_len, "%s %s", text, s_seconds_ml);
    trim(text);
}

stock acs_read_flags(flags[]) {
    new i_i;
    if (flags[i_i] == '!')
        i_i++;
    if (i_i)
        return !flags[i_i] || flags[i_i] == '0' ? -1 : ~read_flags(flags[i_i]);
    else
        return !flags[i_i] || flags[i_i] == '0' ? 0 : read_flags(flags[i_i]);
}

enum { MIN_START, HOUR_START, MIN_END, HOUR_END }

stock pack_interval(str[]) {
    static bytes[4];
    new s_tmp[2][ACS_MAX_INT_STR_LENGTH], s_value[4][ACS_MAX_INT_STR_LENGTH / 2];
    strtok(str, s_tmp[0], charsmax(s_tmp[]), s_tmp[1], charsmax(s_tmp[]), '-', 1);
    strtok(s_tmp[0], s_value[0], charsmax(s_value[]), s_value[1], charsmax(s_value[]), ':', 1);
    strtok(s_tmp[1], s_value[2], charsmax(s_value[]), s_value[3], charsmax(s_value[]), ':', 1);
    bytes[0] = str_to_num(s_value[0]); bytes[1] = str_to_num(s_value[1]);
    bytes[2] = str_to_num(s_value[2]); bytes[3] = str_to_num(s_value[3]);
    //log_acs("[WCS] str = %s, s_tmp[0] = %s, s_tmp[1] = %s", str, s_tmp[0], s_tmp[1]);
    //log_acs("[WCS] [0] = %s, [1] = %s, [2] = %s, [3] = %s", s_value[0], s_value[1], s_value[2], s_value[3]);
    if (bytes[0] > 0xFF || bytes[2] > 0xFF) 
        return _WORD(bytes[0]) + (_WORD(bytes[2]) << 16);
    else
        if (!s_value[1][0] && !s_value[3][0] && bytes[0] <= 0xFF && bytes[2] <= 0xFF)
            return _BYTE(bytes[0]) + (_BYTE(bytes[2]) << 16);
        else
            return (_BYTE(bytes[0]) << 8) + _BYTE(bytes[1]) + (_BYTE(bytes[2]) << 24) + (_BYTE(bytes[3]) << 16);
}

stock unpack_interval(interval, format) {
    new s_tmp[ACS_MAX_NAME_LENGTH]; // = "ERROR";
    static i_start, i_end, i_round_diff;
    //acs_client_print(0, ACS_SHOW_SILIENT, "CURRENT_ROUND = %d, diff = %d", get_current_round(i_round_diff), i_round_diff);
    switch (format) {
        case INTERVAL_NORMAL:
            formatex(_SC(s_tmp), "%d", clamp(interval, 0));
        case INTERVAL_ROUNDS: {
            get_current_round(i_round_diff);
            i_start = clamp(_WORD(interval) - i_round_diff, 0);
            i_end = clamp(_WORD(interval >>> 16) - i_round_diff, 0);
            //log_acs("[UNPACK] interval = %X, start = %X, end = %X", interval, i_start, i_end);
            if (i_start == i_end)
                formatex(_SC(s_tmp), "%d", i_start)
            else if (i_end) 
                formatex(_SC(s_tmp), "%d-%d", i_start, i_end)
            else
                formatex(_SC(s_tmp), "%d+", i_start);
        }
        case INTERVAL_TIME: {
            formatex(_SC(s_tmp), "%d:%d-%d:%d", _BYTE(interval >>> 8), _BYTE(interval), _BYTE(interval >>> 24), _BYTE(interval >>> 16));
        }
    }
    return s_tmp;
}

stock fmt_date(const format[] = "%Y-%m-%d %H:%M:%S") {
    new s_date[ACS_MAX_NAME_LENGTH];
    if (format[0])
        format_time(_SC(s_date), format);
    return s_date;
}

stock fmt_time(const format[] = "%H:%M") {
    return fmt_date(format);
}

// 0-16 = HOUR_START = 0, MIN_START = 0, HOUR_END = 16, MIN_END = 0
// 24 = HOUR_START = 16, MIN_START = 0
// limit_rounds = -3, rounds = 4 => [0] HOUR_START = 3, MIN_START = 0, HOUR_END = 0, MIN_END = 0
// limit_rounds = -3, rounds = 4 => [1] HOUR_START = 4, MIN_START = 0, HOUR_END = 0, MIN_END = 0
// limit_time = D0F000A, time = 300F,

//[WEAPONS] ADV_LIMIT: limit_players_count = 65536, players_count = 1
//[WEAPONS] [TEST] [0][0] = 0, [1][0] = 1, inversion = 0
//[WEAPONS] [TEST] [0][1] = 0, [1][1] = 0, inversion = 0
//[WEAPONS] [TEST] [0][2] = 1, [1][2] = 0, inversion = 0
//[WEAPONS] [TEST] [0][3] = 0, [1][3] = 0, inversion = 0

stock is_interval_located(const interval, const value) {
    static i_i, range[2][4], bool:b_inversion;
    if (!interval)
        return true;
    if (interval < 0)
        b_inversion = true;
    for (i_i = 0; i_i < 4; i_i++) {
        range[0][i_i] = _BYTE(b_inversion ? ((-1) * interval) >>> (8 * i_i) : interval >>> (8 * i_i));
        if (b_inversion && !i_i)
            range[0][i_i]++;
        range[1][i_i] = _BYTE(value >>> (8 * i_i));
        //acs_client_print(0, 0, "[TEST] [0][%d] = %d, [1][%d] = %d, inversion = %d", i_i, range[0][i_i], i_i, range[1][i_i], b_inversion);
    }
    if (!(range[0][HOUR_START] == range[0][HOUR_END] && range[0][MIN_START] == range[0][MIN_END])) {
        if (range[0][HOUR_START] < range[0][HOUR_END] || (range[0][HOUR_START] == range[0][HOUR_END] && range[0][MIN_START] <= range[0][MIN_END])) {
            if ((range[1][HOUR_START] > range[0][HOUR_START] || (range[1][HOUR_START] == range[0][HOUR_START] && range[1][MIN_START] >= range[0][MIN_START]))
                && (range[1][HOUR_START] < range[0][HOUR_END] || (range[1][HOUR_START] == range[0][HOUR_END] && range[1][MIN_START] < range[0][MIN_END])
                    //|| range[1][HOUR_START] == range[0][HOUR_END] && range[1][MIN_START] == range[0][MIN_END] && !(range[0][HOUR_START] | range[0][MIN_START])
                ))
                return true ^ b_inversion;
        } else {
            if (range[1][HOUR_START] > range[0][HOUR_START] || (range[1][HOUR_START] == range[0][HOUR_START] && range[1][MIN_START] >= range[0][MIN_START]))
                return true ^ b_inversion;
            if (range[1][HOUR_START] < range[0][HOUR_END] || (range[1][HOUR_START] == range[0][HOUR_END] && range[1][MIN_START] < range[0][MIN_END]))
                return true ^ b_inversion;
        }
    }
    return false ^ b_inversion;
}

stock add_menu_reason(const id, const interval, &reason_index, reason[], const reason_len, const interval_format = 0) {
    if (interval)
        format(_SL(reason), "%s, %s", reason, fmt("%L", id, fmt("ACS_WCSMENU_LIMIT_REASON_%d", reason_index), unpack_interval(interval, interval_format)));
    reason_index++;
    return interval;
}

stock add_menu_reason2(const interval, &reason_index, f_data[ACS_WCS_FILTER_TASK], const interval_format = 0) {
    if (!f_data[ACS_FT_GIVE_ITEMS] && interval)
        format(_SC(f_data[ACS_FT_REASON]), "%s, %s", f_data[ACS_FT_REASON], fmt("%L", f_data[ACS_FT_ID], fmt("ACS_WCSMENU_LIMIT_REASON_%d", reason_index), unpack_interval(interval, interval_format)));
    reason_index++;
    return interval;
}

stock acs_exec_native(const id, const str[], const has_second_param = false, const any:value = 0) {
    static s_plugin[ACS_MAX_NAME_ML_LENGTH], s_native[ACS_MAX_NAME_ML_LENGTH];
    strtok(str, _SC(s_plugin), _SC(s_native), ':', 1);
    if (s_plugin[0] && s_native[0]) {
        switch (callfunc_begin(s_native, s_plugin)) {
            case -2: log_acs("[WCS] EXT_CALL: function <%s> in plugin [ %s ] not found", s_native, s_plugin);
            case -1: log_acs("[WCS] EXT_CALL: plugin [ %s ] not found", s_plugin);
            case 0: log_acs("[WCS] EXT_CALL: function <%s> in plugin [ %s ] timeout", s_native, s_plugin);
            case 1: {
                callfunc_push_int(id);
                if (has_second_param)
                    callfunc_push_int(value);
                return callfunc_end();
                //log_acs("[WCS] EXT_CALL: function <%s> in plugin [ %s ] done", s_native, s_plugin);
            }
        }
    }
    return -1;
}

stock bool:acs_offline(const nv_set, const cmd, const key[] = "", value[] = "", const max_size = 0, const module_name[] = "") {
    new bool:b_result;
    switch(cmd) {
        case ACS_OFFLINE_INIT:  b_result = acs_offline_init(nv_set, module_name);
        case ACS_OFFLINE_RESET: b_result = acs_offline_reset(nv_set, (key[0] && is_str_num(key)) ? str_to_num(key) : -1);
        case ACS_OFFLINE_SET:   b_result = acs_offline_set(nv_set, key, value);
        case ACS_OFFLINE_PSET:  b_result = acs_offline_set(nv_set, key, value, true);
        case ACS_OFFLINE_GET:   b_result = acs_offline_get(nv_set, key, value, max_size);
    }
    return b_result;
}

stock bool:acs_offline_init(const nv_set, const nv_name[]) {
    static i_i;
    new bool:b_result;
    if (nv_name[0] && nv_set >= 0 && nv_set < ACS_OFFLINE_SETS) {
        if (!(b_result = gh_nvault[nv_set][NVLT_HANDLE] >= 0)) {
            gh_nvault[nv_set][NVLT_LOADED] = false;
            formatex(gh_nvault[nv_set][NVLT_NAME], charsmax(gh_nvault[][NVLT_NAME]), "%s_%d", nv_name, nv_set);
            if ((b_result = (gh_nvault[nv_set][NVLT_NAME][0] && (gh_nvault[nv_set][NVLT_HANDLE] = nvault_open(gh_nvault[nv_set][NVLT_NAME])) >= 0)))
                log_acs("[ACS] nvault[ %d ] open <%s>", nv_set, gh_nvault[nv_set][NVLT_NAME]);
            else
                log_acs("[ACS] Error: can't open nvault[ %d ] <%s>", nv_set, gh_nvault[nv_set][NVLT_NAME]);
        }
    } else
        for (i_i = 0; i_i < ACS_OFFLINE_SETS; i_i++) {
            gh_nvault[i_i][NVLT_HANDLE] = -1;
            if (nv_name[0])
                acs_offline(i_i, ACS_OFFLINE_INIT, "", "", 0, nv_name);
        }
    return b_result;
}

stock bool:acs_offline_reset(const nv_set, const system_time) {
    static i_count;
    new bool:b_result;
    if ((b_result = (gh_nvault[nv_set][NVLT_HANDLE] >= 0))) {
        i_count = nvault_prune(gh_nvault[nv_set][NVLT_HANDLE], 0, (system_time > 0 ? system_time : get_systime()));
        log_acs("[ACS] nvault[ %d ] <%s>, was deleted %d records", nv_set, gh_nvault[nv_set][NVLT_NAME], i_count);
    }
    return b_result; 
}

stock bool:acs_offline_set(const nv_set, const key[], value[], const is_persistent = false) {
    new bool:b_result;
    if ((b_result = (gh_nvault[nv_set][NVLT_HANDLE] >= 0))) {
        if (is_persistent)
            nvault_pset(gh_nvault[nv_set][NVLT_HANDLE], key, value);
        else
            nvault_set(gh_nvault[nv_set][NVLT_HANDLE], key, value);
    }
    return b_result;
}

stock bool:acs_offline_get(const nv_set, const key[], value[], const max_size) {
    new bool:b_result;
    if ((b_result = (gh_nvault[nv_set][NVLT_HANDLE] >= 0))) {
        b_result = bool:nvault_get(gh_nvault[nv_set][NVLT_HANDLE], key, value, max_size);
    }
    return b_result;
}

stock menu_set_timeout(const id, const menu, const time) {
    // (c) OciXCrom
    // https://forums.alliedmods.net/showthread.php?t=294087
    static a_data[2], i_task;
    if (time > 0) {
        a_data[0] = id;
        a_data[1] = menu;
        i_task = id + TASK_MENU_TIMEOUT;
        if (task_exists(i_task))
            remove_task(i_task)
        set_task(float(time), "task_remove_menu", i_task, a_data, sizeof(a_data))
    }
}

public task_remove_menu(a_data[2]) {
    static m_data[3], id;
    //log_acs("[MENU] MENU TASK: id = %d, h_menu = %d", a_data[0], a_data[1]);
    if (is_valid_player((id = a_data[0]))) {
        m_data[0] = a_data[1];
        if (player_menu_info(id, m_data[2], m_data[1])) {
            if(m_data[1] == m_data[0]) {
                menu_cancel(id);
                show_menu(id, 0, "^n", 1);
            }
        }
    }
}

stock acs_give_item_ex(const id, const weapon[], count = 0, GiveType:type = GT_APPEND) {
    static i_entity;
    //log_acs("give_item_ex(): id = %d, weapon = %s, count = %d", id, weapon, count);
    i_entity = rg_give_item(id, weapon, type);
    if (!is_nullent(i_entity) && count) {
        rg_set_iteminfo(i_entity, ItemInfo_iMaxAmmo1, count);
        rg_set_user_bpammo(id, rg_get_weapon_info(weapon, WI_ID), count);
    }// else
        //log_acs("give_item_ex(): error! id = %d, weapon = %s, count = %d, type = %d", id, weapon, count, type);
}

stock acs_set_max_ammo(id, entity /*, bool:is_primary = false*/) {
    static WeaponIdType:i_wid, i_ammo, i_clip, s_class_name[ACS_MAX_NAME_LENGTH];
    //acs_client_print(id, ACS_SHOW_DEBUG, "MAX_AMMO: entity = %d", entity);
    if (!is_nullent(entity)) {
        get_entvar(entity, var_classname, _SC(s_class_name));
        i_wid = rg_get_weapon_info(s_class_name, WI_ID);
        if ((i_clip = int:rg_get_iteminfo(entity, ItemInfo_iMaxClip)) > 0)
            rg_set_user_ammo(id, i_wid, i_clip);
        if ((i_ammo = int:rg_get_iteminfo(entity, ItemInfo_iMaxAmmo1)) > 0)
            rg_set_user_bpammo(id, i_wid, i_ammo);
        //acs_client_print(id, ACS_SHOW_DEBUG, "MAX_AMMO: classname = %s, wid = %d, clip = %d, ammo = %d", s_class_name, i_wid, i_clip, i_ammo);
    }
}

stock acs_remove_entity(const entity, bool:force_remove = false) {
    set_entvar(entity, var_flags, FL_KILLME);
    set_entvar(entity, var_targetname, 0);
    set_entvar(entity, var_nextthink, get_gametime());
    if (force_remove)
        dllfunc(DLLFunc_Think, entity);
}


stock acs_drop_weapons(id, InventorySlotType:slot) {
    if (is_valid_player(id) && CVAR[GIVE_TYPE] != APPEND_SLOT) {
        if(CVAR[GIVE_TYPE] != REMOVE_SLOT) {
            new i_entity = get_member(id, m_rgpPlayerItems, slot);
            if(CVAR[GIVE_TYPE] == DROP_SLOT) {
                while (!is_nullent(i_entity)) {
                    i_entity = get_member(i_entity, m_pNext);
                    rg_drop_items_by_slot(id, slot);
                }
            }
        } else
            rg_remove_items_by_slot(id, slot);
    }
}

stock bool:check_custom_weapon(entity, key) {
    return (!is_nullent(entity)) && (0 <= key - WCS_IMPULSE_OFFSET < gi_weapon_count) && get_cw(entity) == key;
}

stock acs_check_throttling(id) {
    new Float:f_time, Float:f_delta;
    f_time = get_gametime();
    f_delta = f_time - ACS_PRINT_THR[id][LAST_USAGE];
    if (ACS_PRINT_THR[id][FLAG]) {
        if (f_delta > 4 * 0.75)
            ACS_PRINT_THR[id][FLAG] = false;
    } else if (f_delta < 0.75)
        ACS_PRINT_THR[id][FLAG] = true;
    ACS_PRINT_THR[id][LAST_USAGE] = f_time;
    return !ACS_PRINT_THR[id][FLAG];
}

stock acs_client_print(const id, const notify_mode, const message[], any:...) {
    static s_tmp[190];
    if (CVAR[NOTIFY_MODE] && ((id == 0) || is_valid_player(id)) && ((!((CVAR[NOTIFY_SOUND_MODE] & ACS_SOUND_MASK) & notify_mode)) || acs_check_throttling(id))) {
        vformat(s_tmp, charsmax(s_tmp), message, 4);
        if (CVAR[PREFIX])
            format(s_tmp, charsmax(s_tmp), "%s %s", CVAR[PREFIX], s_tmp);
        client_print_color(id, ((notify_mode & (ACS_SHOW_NO_ACCESS | ACS_SHOW_NO_ACCESS2 | ACS_SHOW_LIMIT_PLAYER | ACS_SHOW_LIMIT_TEAM | ACS_SHOW_LIMIT_TOTAL)) ? print_team_red : print_team_blue), s_tmp);
        if ((CVAR[NOTIFY_SOUND_MODE] & ACS_SOUND_MASK) & notify_mode)
            acs_send_audio(id, ((notify_mode & (ACS_SHOW_GET | ACS_SHOW_BUY)) ? ACS_SOUND_NOTIFY : ACS_SOUND_REJECT));
    }
}

stock acs_blink_account(id, count = 5) {
    static i_msg;
    if (is_valid_player(id) && is_user_alive(id)) {
        if ((CVAR[NOTIFY_MODE] & ACS_SHOW_BLINK) && (i_msg || (i_msg = get_user_msgid("BlinkAcct")))) {
            message_begin(MSG_ONE_UNRELIABLE, i_msg, .player = id);
            {
                write_byte(count);
            }
            message_end();
        }
    }
}

stock bool:is_team_dominate(id) {
	new i_diff;
	return (is_valid_player(id) && CVAR[DIFF] && (get_member(id, m_iTeam) == acs_get_team_dominate(i_diff))) ? (i_diff > CVAR[DIFF]) : false;
}

stock TeamName:acs_get_team_dominate(&diff) {
	new TeamName:t_team;
	t_team = TEAM_UNASSIGNED;
	if ((diff = CVAR[DIFF_MODE] ? get_member_game(m_iNumConsecutiveCTLoses) - get_member_game(m_iNumConsecutiveTerroristLoses) : get_member_game(m_iNumTerroristWins) - get_member_game(m_iNumCTWins)) > 0)
		t_team = TEAM_TERRORIST;
	else if (diff < 0)
		t_team = TEAM_CT;
	diff = abs(diff);
	return t_team;
}

stock get_aes_native(const id, const function[], const has_second_param = false, const any:value = 0) {
    return acs_exec_native(id, fmt("%s:%s", CVAR[AES_PLUGIN], function), has_second_param, value);
}

stock Float:acs_get_player_exp(const id) {
    return Float:get_aes_native(id, "_aes_get_player_exp");
}

stock acs_get_player_bonus(const id) {
    return get_aes_native(id, "_aes_get_player_bonus");
}

stock acs_set_player_bonus(const id, const value) {
    return get_aes_native(id, "_aes_set_player_bonus", true, value);
}

stock acs_add_player_bonus(const id, const value) {
    return get_aes_native(id, "_aes_add_player_bonus", true, value);
}

stock acs_add_player_exp(const id, const Float:value) {
    return get_aes_native(id, "_aes_add_player_exp", true, value);
}

stock get_current_round(&diff = 0) {
    diff = gi_total_rounds_played - get_member_game(m_iTotalRoundsPlayed) - 1;
    return CVAR[ROUND_CONTROL] ? gi_total_rounds_played : get_member_game(m_iTotalRoundsPlayed) + 1;
}

stock acs_create_entity(classname[], bool:use_hash_table = false) {
    static i_entity;
    i_entity = -1;
    if (!is_entity_max_count())
        i_entity = rg_create_entity(classname, use_hash_table);
    return i_entity;
}

stock acs_get_gamecms_data(const id) {
    static s_data[ACS_MAX_INT_STR_LENGTH], s_async_query[2 * ACS_MAX_BUFFER_SIZE];
    if (is_valid_player(id)) {
        ga_gamecms_data[id][GAMECMS_TIMELEFT] = 0;
        ga_gamecms_data[id][GAMECMS_TIMELEFT_TEXT][0] = 0;
        ga_gamecms_data[id][GAMECMS_LOADED] = false;
        get_user_name(id, ga_gamecms_data[id][GAMECMS_NAME], charsmax(ga_gamecms_data[][GAMECMS_NAME]));
        get_user_authid(id, ga_gamecms_data[id][GAMECMS_AUTHID], charsmax(ga_gamecms_data[][GAMECMS_AUTHID]));
        if (CVAR[GAMECMS_ENABLE] && !is_user_bot(id)) {
            formatex(_SC(s_data), "%d", id);
            formatex(_SC(s_async_query), "SELECT * FROM admins as aa LEFT JOIN admins__services as vv on vv.admin_id = aa.id INNER JOIN services as ss on ss.id = vv.service LEFT JOIN servers as rr on rr.id = aa.server WHERE (aa.name = '%s' or aa.name = '%s') and rr.address = '%s' and LEFT(ss.rights, 1) != '_' order by vv.ending_date DESC LIMIT 1", ga_gamecms_data[id][GAMECMS_NAME], ga_gamecms_data[id][GAMECMS_AUTHID], gs_hostname);
            if (gh_sql_tuple != Empty_Handle)
                SQL_ThreadQuery(gh_sql_tuple, "acs_query_handler", s_async_query, _SS(s_data));
        }
    }
}