#include <acs_wcs>

/*
set_cvar_string("mp_forcerespawn", "0");
set_cvar_string("mp_respawn_immunitytime", "0");
set_cvar_string("mp_round_infinite", "0");
*/

public acs_stats() {
    new i_sum;
    log_acs("CVAR = %d ", sizeof(CVAR)); i_sum += sizeof(CVAR);
    log_acs("ga_weapon_data = %d ", ArraySize(ga_weapon_data) * ACS_WCS); i_sum += ArraySize(ga_weapon_data) * ACS_WCS;
    log_acs("ga_weapon_limit = %d ", ArraySize(ga_weapon_limit) * ACS_WCS_LIMITS); i_sum += ArraySize(ga_weapon_limit) * ACS_WCS_LIMITS;
    log_acs("ga_menu_data = %d ", ArraySize(ga_menu_data) * ACS_WCS_MENU); i_sum += ArraySize(ga_menu_data) * ACS_WCS_MENU;
    log_acs("ga_adv_limits = %d ", ArraySize(ga_adv_limits) * ACS_WCS_ADV_LIMITS); i_sum += ArraySize(ga_adv_limits) * ACS_WCS_ADV_LIMITS;
    log_acs("ga_filters = %d ", ArraySize(ga_filters[0]) * ACS_WCS_ADV_FILTER_TYPES * ACS_WCS_AVD_FILTERS); i_sum += ArraySize(ga_filters[0]) * ACS_WCS_ADV_FILTER_TYPES * ACS_WCS_AVD_FILTERS;
    log_acs("gt_weapon_owner = %d ", TrieGetSize(gt_weapon_owner)); i_sum += TrieGetSize(gt_weapon_owner);
    log_acs("gt_weapon_limit = %d ", TrieGetSize(gt_weapon_limit)); i_sum += TrieGetSize(gt_weapon_limit);
    log_acs("gt_adv_limit = %d ", TrieGetSize(gt_adv_limit)); i_sum += TrieGetSize(gt_adv_limit);
    log_acs("gt_weapon_clcmd = %d ", TrieGetSize(gt_weapon_clcmd)); i_sum += TrieGetSize(gt_weapon_clcmd);
    log_acs("gt_weapon_recoil = %d ", TrieGetSize(gt_weapon_recoil)); i_sum += TrieGetSize(gt_weapon_recoil);
    log_acs("gf_touch_time = %d ", sizeof(gf_touch_time)); i_sum += sizeof(gf_touch_time);
    log_acs("ACS_PRINT_THR = %d ", sizeof(ACS_PRINT_THR)); i_sum += sizeof(ACS_PRINT_THR);
    log_acs("gi_add_speed = %d ", sizeof(gi_add_speed)); i_sum += sizeof(gi_add_speed);
    log_acs("ga_damager = %d ", sizeof(ga_damager)); i_sum += sizeof(ga_damager);
    log_acs("TOTAL = %d ", i_sum );
    log_acs("ENTITY COUNT = %d (%d)", entity_count(), gi_max_entities);
}

public plugin_init() {
    static i_i;
    register_plugin("ACS Weapon Control System", "1.1.6.3", "DEV-CS.RU");
    //register_event("HLTV", "new_round", "a", "1=0", "2=0");
    RegisterHookChain(RG_CSGameRules_CheckMapConditions, "new_round", true);
    RegisterHookChain(RG_RoundEnd, "RoundEnd_Pre");
    register_concmd("wcsmenu", "cmd_menu");
    register_concmd("vipmenu", "cmd_menu");
    register_concmd("wcstest", "cmd_wcstest");
    register_concmd("acs_give_weapon", "cmd_give_weapon", ADMIN_ALL, "<name or #userid> <weapon_name>");
    register_concmd("round_end", "cmd_round_end", ADMIN_RCON, "<delay> <id string>");
    register_concmd("remove_all_weapons", "cmd_remove_all_weapons", ADMIN_RCON);
    RegisterHam(Ham_Touch, "weaponbox", "Touch_Pre");                                                   
    RegisterHam(Ham_TraceAttack, "player", "TraceAttack_Post", true);
    RegisterHam(Ham_TraceAttack, "worldspawn", "TraceAttack_Post", true);
    RegisterHam(Ham_TraceAttack, "info_target", "TraceAttack_Post", true);
    RegisterHam(Ham_TraceAttack, "func_breakable", "TraceAttack_Post", true);
    RegisterHam(Ham_TraceAttack, "hostage_entity", "TraceAttack_Post", true);
    RegisterHookChain(RG_CWeaponBox_SetModel, "CWeaponBox_SetModel_Pre");                               
    //RegisterHookChain(RG_CSGameRules_PlayerSpawn, "CSGameRules_PlayerSpawn_Post", true);     
    RegisterHookChain(RG_CBasePlayer_OnSpawnEquip, "CBasePlayer_OnSpawnEquip_Post", true);           
    //RegisterHookChain(RG_CBasePlayer_Spawn, "CBasePlayer_Spawn_Post", true);                          
    RegisterHookChain(RG_CBasePlayer_HasRestrictItem, "CBasePlayer_HasRestrictItem_Pre");              
    RegisterHookChain(RG_CBasePlayer_ResetMaxSpeed, "CBasePlayer_ResetMaxSpeed_Post", true);            
    RegisterHookChain(RG_CSGameRules_CanHavePlayerItem, "CSGameRules_CanHavePlayerItem_Pre");           
    RegisterHookChain(RG_CBasePlayerWeapon_DefaultDeploy, "CBasePlayerWeapon_DefaultDeploy_Pre");   
    RegisterHookChain(RG_CSGameRules_DeadPlayerWeapons, "CSGameRules_DeadPlayerWeapons_Pre");              
    RegisterHookChain(RG_CBasePlayer_Killed, "CBasePlayer_Killed_Post", true);
    RegisterHookChain(RG_CBasePlayer_TakeDamage, "CBasePlayer_TakeDamage_Post", true);
    if (!register_dictionary("acs_wcs.txt"))
        log_acs("Error: dictionary file not found!");
    is_recoil_module_loaded = bool:get_cvar_pointer("af_recoil_all");
    gi_max_entities = get_global_int(GL_maxEntities);
    for (i_i = 0; i_i < sizeof(gh_hudsync_damager); i_i++) {
        gh_hudsync[i_i] = CreateHudSyncObj();
        gh_hudsync_damager[i_i] = CreateHudSyncObj(); //худ
    }
    log_acs("Total entity on map: %d", entity_count());
}

public plugin_precache() {
    if (file_exists(fmt("sound/%s", ACS_SOUND_NOTIFY)))
        precache_sound(ACS_SOUND_NOTIFY);
    if (file_exists(fmt("sound/%s", ACS_SOUND_REJECT)))
        precache_sound(ACS_SOUND_REJECT);
    if (file_exists(ACS_SPRITE_LAZER))
        gh_lazer_beam = precache_model(ACS_SPRITE_LAZER);
    else
        log_acs("Error: sprite of lazer beam not found!");
    acs_cfg("acs_wcs.ini");
}

public plugin_cfg() {
    bind_pcvar_string(create_cvar("acs_wcs_prefix", "^4[WEAPONS]", .description = fmt("%L", LANG_SERVER, "CVAR_PREFIX")), _SC(CVAR[PREFIX]));
    bind_pcvar_float(create_cvar("acs_wcs_buy_time", "0.0", FCVAR_PROTECTED, .description = fmt("%L", LANG_SERVER, "CVAR_BUYTIME"), .has_min = true, .min_val = 0.0), CVAR[BUYTIME]);
    bind_pcvar_num(create_cvar("acs_wcs_buy_zone", "0", FCVAR_PROTECTED, .description = fmt("%L", LANG_SERVER, "CVAR_BUYZONE"), .has_min = true, .min_val = 0.0, .has_max = true, .max_val = 1.0), CVAR[BUYZONE]);
    bind_pcvar_num(create_cvar("acs_wcs_discount", "0", FCVAR_PROTECTED, .description = fmt("%L", LANG_SERVER, "CVAR_DISCOUNT"), .has_min = true, .min_val = 0.0, .has_max = true, .max_val = 100.0), CVAR[DISCOUNT]);
    bind_pcvar_string(create_cvar("acs_wcs_cmd_access", "s", FCVAR_PROTECTED, .description = fmt("%L", LANG_SERVER, "CVAR_CMD_ACCESS")), _SC(CVAR[CMD_ACCESS]));
    bind_pcvar_num(create_cvar("acs_wcs_give_type", "2", FCVAR_PROTECTED, .description = fmt("%L", LANG_SERVER, "CVAR_GIVE_TYPE"), .has_min = true, .min_val = 0.0, .has_max = true, .max_val = 2.0), CVAR[GIVE_TYPE]);
    bind_pcvar_num(create_cvar("acs_wcs_pickup_access_type", "1", FCVAR_PROTECTED, .description = fmt("%L", LANG_SERVER, "CVAR_PICKUP_ACCESS_TYPE"), .has_min = true, .min_val = 0.0, .has_max = true, .max_val = 1.0), CVAR[PICKUP_ACCESS_TYPE]);
    bind_pcvar_num(create_cvar("acs_wcs_trace_type", "0", FCVAR_PROTECTED, .description = fmt("%L", LANG_SERVER, "CVAR_TRACE_TYPE"), .has_min = true, .min_val = 0.0, .has_max = true, .max_val = 1.0), CVAR[TRACE_TYPE]);
    bind_pcvar_num(create_cvar("acs_wcs_notify_mode", "8191", .description = fmt("%L", LANG_SERVER, "CVAR_NOTIFY_MODE"), .has_min=true, .min_val=0.0, .has_max=true, .max_val=8192.0), CVAR[NOTIFY_MODE]);
    bind_pcvar_num(create_cvar("acs_wcs_notify_sound_mode", "0", .description = fmt("%L", LANG_SERVER, "CVAR_NOTIFY_SOUND_MODE"), .has_min=true, .min_val=0.0, .has_max=true, .max_val=8192.0), CVAR[NOTIFY_SOUND_MODE]);
    bind_pcvar_num(create_cvar("acs_wcs_win_diff_mode", "0", .description = fmt("%L", LANG_SERVER, "CVAR_DIFF_MODE"), .has_min=true, .min_val=0.0, .has_max=true, .max_val=1.0), CVAR[DIFF_MODE]);
    bind_pcvar_string(create_cvar("acs_wcs_aes_plugin_filename", "aes_main.amxx", FCVAR_PROTECTED, .description = fmt("%L", LANG_SERVER, "CVAR_AES_PLUGIN")), _SC(CVAR[AES_PLUGIN]));
    bind_pcvar_num(create_cvar("acs_wcs_restore_maxspeed", "320", .description = fmt("%L", LANG_SERVER, "CVAR_RESTORE_MAXSPEED"), .has_min=true, .min_val=0.0, .has_max=true, .max_val=2000.0), CVAR[RESTORE_MAXSPEED]);
    bind_pcvar_num(create_cvar("acs_wcs_vipmenu_round", "4", .description = fmt("%L", LANG_SERVER, "CVAR_VIPMENU_ROUND"), .has_min=true, .min_val=0.0, .has_max=true, .max_val=100.0), CVAR[VIPMENU_ROUND]);
    bind_pcvar_num(create_cvar("acs_wcs_vipmenu_timeout", "10", .description = fmt("%L", LANG_SERVER, "CVAR_VIPMENU_TIMEOUT"), .has_min=true, .min_val=-1.0, .has_max=true, .max_val=30.0), CVAR[VIPMENU_TIMEOUT]);
    bind_pcvar_num(create_cvar("acs_wcs_vipmenu_mode", "1", .description = fmt("%L", LANG_SERVER, "CVAR_VIPMENU_MODE"), .has_min=true, .min_val=0.0, .has_max=true, .max_val=100.0), CVAR[VIPMENU_MODE]);
    bind_pcvar_num(create_cvar("acs_wcs_max_item_money", "16000", .description = fmt("%L", LANG_SERVER, "CVAR_MAX_MONEY"), .has_min=true, .min_val=1.0, .has_max=true, .max_val=16000.0), CVAR[MAX_MONEY]);
    bind_pcvar_num(create_cvar("acs_wcs_max_item_hp", "100", .description = fmt("%L", LANG_SERVER, "CVAR_MAX_HP"), .has_min=true, .min_val=1.0, .has_max=true, .max_val=1000.0), CVAR[MAX_HP]);
    bind_pcvar_num(create_cvar("acs_wcs_max_item_armor", "100", .description = fmt("%L", LANG_SERVER, "CVAR_MAX_ARMOR"), .has_min=true, .min_val=1.0, .has_max=true, .max_val=1000.0), CVAR[MAX_ARMOR]);
    bind_pcvar_num(create_cvar("acs_wcs_max_item_ammo", "250", .description = fmt("%L", LANG_SERVER, "CVAR_MAX_AMMO"), .has_min=true, .min_val=1.0, .has_max=true, .max_val=1000.0), CVAR[MAX_AMMO]);
    bind_pcvar_num(create_cvar("acs_wcs_max_item_speed", "900", .description = fmt("%L", LANG_SERVER, "CVAR_MAX_SPEED"), .has_min=true, .min_val=1.0, .has_max=true, .max_val=2000.0), CVAR[MAX_SPEED]);
    bind_pcvar_num(create_cvar("acs_wcs_round_control", "1", FCVAR_PROTECTED, .description = fmt("%L", LANG_SERVER, "CVAR_ROUND_CONTROL"), .has_min = true, .min_val = 0.0, .has_max = true, .max_val = 1.0), CVAR[ROUND_CONTROL]);
    bind_pcvar_string(create_cvar("acs_wcs_server_name", "", FCVAR_PROTECTED, .description = fmt("%L", LANG_SERVER, "CVAR_SERVER_NAME")), _SC(CVAR[SERVER_NAME]));
    bind_pcvar_num(create_cvar("acs_wcs_gamecms_enable", "0", FCVAR_PROTECTED, .description = fmt("%L", LANG_SERVER, "CVAR_GAMECMS_ENABLE"), .has_min = true, .min_val = 0.0, .has_max = true, .max_val = 1.0), CVAR[GAMECMS_ENABLE]);
    bind_pcvar_string(create_cvar("acs_wcs_gamecms_db_host", "", FCVAR_PROTECTED, .description = fmt("%L", LANG_SERVER, "CVAR_GAMECMS_DB_HOST")), _SC(CVAR[GAMECMS_DB_HOST]));
    bind_pcvar_string(create_cvar("acs_wcs_gamecms_db_name", "", FCVAR_PROTECTED, .description = fmt("%L", LANG_SERVER, "CVAR_GAMECMS_DB_NAME")), _SC(CVAR[GAMECMS_DB_NAME]));
    bind_pcvar_string(create_cvar("acs_wcs_gamecms_db_user", "", FCVAR_PROTECTED, .description = fmt("%L", LANG_SERVER, "CVAR_GAMECMS_DB_USER")), _SC(CVAR[GAMECMS_DB_USER]));
    bind_pcvar_string(create_cvar("acs_wcs_gamecms_db_pass", "", FCVAR_PROTECTED, .description = fmt("%L", LANG_SERVER, "CVAR_GAMECMS_DB_PASS")), _SC(CVAR[GAMECMS_DB_PASS]));
    bind_pcvar_num(create_cvar("acs_wcs_log", "0", FCVAR_PROTECTED, .description = fmt("%L", LANG_SERVER, "CVAR_LOG"), .has_min = true, .min_val = 0.0, .has_max = true, .max_val = 1.0), CVAR[LOG]);
    new b_flag = CVAR[GAMECMS_DB_HOST][0] && CVAR[GAMECMS_DB_NAME][0] && CVAR[GAMECMS_DB_USER][0] && CVAR[GAMECMS_DB_PASS][0];
    if (!(b_flag && (gh_sql_tuple = SQL_MakeDbTuple(CVAR[GAMECMS_DB_HOST], CVAR[GAMECMS_DB_USER], CVAR[GAMECMS_DB_PASS], CVAR[GAMECMS_DB_NAME], 3)) != Empty_Handle)) {
        CVAR[GAMECMS_ENABLE] = 0;
        if (b_flag)
            log_acs("[WCS] GAMECMS: SQL connection error!");
    }
    get_user_ip(0, gs_hostname, charsmax(gs_hostname), 0);
    acs_offline(-1, ACS_OFFLINE_INIT, "", "", 0, "acs_weapons");
    get_mapname(_SC(gs_mapname));
    gi_round_time = floatround(get_cvar_float("mp_roundtime") * 60, floatround_ceil);
    AutoExecConfig(true, "acs_wcs");
}

public plugin_natives() {

}

public plugin_end() {
}

public client_connect(id) {
}

public client_putinserver(id) {
    if(!is_user_hltv(id)) {
        set_bit(gi_client_connected, id);
        acs_get_gamecms_data(id);
    }
}

public client_disconnected(id, bool:drop, message[], maxlen) {
    reset_bit(gi_client_connected, id);
    gf_touch_time[id] = 0.0;
}

public new_round() {
    gb_round_infinite = get_cvar_num("mp_round_infinite") || get_cvar_num("mp_forcerespawn");
    gi_total_rounds_played++;
    if (task_exists(TASK_TIMER))
        remove_task(TASK_TIMER);
    if (task_exists(TASK_PROCESS))
        remove_task(TASK_PROCESS);
    ArrayClear(ga_weapon_limit);
    TrieClear(gt_weapon_limit);
    TrieClear(gt_weapon_owner);
    if (CVAR[RESTORE_MAXSPEED] > 0 && CVAR[RESTORE_MAXSPEED] != get_cvar_num("sv_maxspeed"))
        set_cvar_num("sv_maxspeed", CVAR[RESTORE_MAXSPEED]);
    log_acs("CURRENT ROUND = %d, m_bGameStarted = %d", get_current_round(), get_member_game(m_bGameStarted));
}

public RoundEnd_Pre(WinStatus:status, ScenarioEventEndRound:event, Float:tmDelay) {
    if (CVAR[ROUND_CONTROL] && event == ROUND_GAME_COMMENCE) {
        set_member_game(m_bGameStarted, true);
        SetHookChainReturn(ATYPE_BOOL, false);
        return HC_SUPERCEDE;
    }
    acs_stats();
    return HC_CONTINUE;
}

public cmd_round_end(id, level, cid) {
    static i_id, Float:f_delay, s_delay[ACS_MAX_INT_STR_LENGTH / 4], s_id[ACS_MAX_INT_STR_LENGTH / 4]
    if (cmd_access(id, level, cid, 2)) {
        read_argv(1, s_delay, charsmax(s_delay));
        read_argv(2, s_id, charsmax(s_id));
        i_id = clamp(str_to_num(s_id), 0);
        f_delay = floatclamp(str_to_float(s_delay), 0.1, 10.0);
        set_member_game(m_bCompleteReset, true);
        rg_round_end(f_delay, WINSTATUS_DRAW, ROUND_GAME_RESTART, fmt("%L", id, fmt("ACS_WCSROUND_END_%d", i_id), floatround(f_delay)), _, true);
    }
    return PLUGIN_HANDLED;
}

public cmd_remove_all_weapons(id, level, cid) {
    static i_i;
    if (cmd_access(id, level, cid, 1)) {
        for (i_i = 1; i_i < MAX_PLAYERS + 1; i_i++)
            if (is_valid_player(i_i) && is_user_alive(i_i)) {
                rg_remove_all_items(i_i, true);
                set_user_maxspeed(id, 1.0);
            }
    }
    return PLUGIN_HANDLED;
}

public CBasePlayer_Killed_Post(victim, killer) {
    static i_weapon, f_data[ACS_WCS_FILTER_TASK], s_class_name[ACS_MAX_NAME_LENGTH];
    if (is_valid_player(victim) && is_valid_player(killer) && victim != killer) {
        get_user_name(victim, _SC(f_data[ACS_FT_NAME]));
        f_data[ACS_FT_ID] = killer;
        f_data[ACS_FT_TYPE] = ACS_ET_KILL;
        f_data[ACS_FT_FILTER] = WCS_ADV_EVENTS;
        f_data[ACS_FT_GIVE_ITEMS] = true;
        set_task(0.1, "acs_check_filter", TASK_EVENT + f_data[ACS_FT_ID], _SS(f_data));
        if (get_member(victim, m_bKilledByBomb)) {
            f_data[ACS_FT_TYPE] = ACS_ET_KILL_BOMB;
            set_task(0.1, "acs_check_filter", TASK_EVENT + f_data[ACS_FT_ID], _SS(f_data));
        }
        if (get_member(victim, m_bKilledByGrenade)) {
            f_data[ACS_FT_TYPE] = ACS_ET_KILL_HE;
            set_task(0.1, "acs_check_filter", TASK_EVENT + f_data[ACS_FT_ID], _SS(f_data));
        }
        if (get_member(victim, m_bHeadshotKilled)) {
            f_data[ACS_FT_TYPE] = ACS_ET_KILL_HS;
            set_task(0.1, "acs_check_filter", TASK_EVENT + f_data[ACS_FT_ID], _SS(f_data));
        }
        if (!is_nullent((i_weapon = get_member(killer, m_pActiveItem)))) {
            get_entvar(i_weapon, var_classname, _SC(s_class_name));
            if (equali(s_class_name, "weapon_knife")) {
                f_data[ACS_FT_TYPE] = ACS_ET_KILL_KNIFE;
                set_task(0.1, "acs_check_filter", TASK_EVENT + f_data[ACS_FT_ID], _SS(f_data));
            }
        }
    }
}

public CBasePlayer_TakeDamage_Post(victim, weapon, killer, Float:damage, damage_type) {
    acs_check_damager(victim, killer, Float:damage, damage_type);
}

//public CSGameRules_PlayerSpawn_Post(id) {    
public CBasePlayer_OnSpawnEquip_Post(id) {
    if (is_valid_player(id)) {
        log_acs("SPAWN POST [ %d ]: id = %d", get_current_round(), id);
        gi_add_speed[id][SPEED_VALUE] = 0;
        gi_add_speed[id][SPEED_RELATIVE] = false;
        ga_damager[id][DMG_ENABLED] = false;    
        if (task_exists(TASK_PROCESS + id))
            remove_task(TASK_PROCESS + id);
        rg_reset_maxspeed(id);
        set_task(0.1, "task_acs_adv_task", TASK_ADV_TASK + id);
    } else
        log_acs("[WCS] Invalid player %d, hltv = %d", id, is_user_hltv(id));
}

public task_acs_adv_task(task_id) {
    static id, i_i, i_stop, i_num, i_weapons[32], i_entity, s_class_name[ACS_MAX_NAME_LENGTH], s_weapon_key[ACS_MAX_NAME_LENGTH];
    new f_data[ACS_WCS_FILTER_TASK];
    id = task_id - TASK_ADV_TASK;
    if (is_valid_player(id) && is_user_alive(id)) {
        f_data[ACS_FT_ID] = id;
        f_data[ACS_FT_TYPE] = 0;
        f_data[ACS_FT_FILTER] = WCS_ADV_TASKS;
        f_data[ACS_FT_GIVE_ITEMS] = true;
        acs_check_filter(f_data);
        i_num = 0;
        get_user_weapons(id, i_weapons, i_num);
        for (i_i = 0; i_i < i_num; i_i++) {
            if (0 < i_weapons[i_i] < any:ITEM_NVG) {
                i_entity = 0; i_stop = 0;
                if (get_weaponname(i_weapons[i_i], _SC(s_class_name))) {
                    log_acs("SPAWN POST [ %d ]: id = %d, item = %d, weapon_class = %s", get_current_round(), id, i_weapons[i_i], s_class_name);
                    //while (!is_nullent((i_entity = find_ent_by_owner(i_entity, s_class_name, id))) && i_entity != i_entity_last && i_stop < 10) {
                    while (rg_find_ent_by_owner(i_entity, s_class_name, id) && !is_nullent(i_entity) && i_stop < 10) {
                        log_acs("SPAWN POST [ %d ]: id = %d, entity = %d", get_current_round(), id, i_weapons[i_i], i_entity);
                        acs_add_weapon_limit(id, s_class_name);
                        if (is_custom_weapon(i_entity)) {
                            formatex(_SC(s_weapon_key), "%d", get_wk(i_entity) - WCS_IMPULSE_OFFSET);
                            acs_add_weapon_limit(id, s_weapon_key);
                            acs_add_weapon_limit(id, ACS_WEAPON_ALL_KEY);
                            TrieSetCell(gt_weapon_owner, fmt("%d", i_entity), get_user_userid(id));
                        }
                        i_entity++;
                        i_stop++;
                    }
                    log_acs("SPAWN POST [ %d ]: id = %d, found %d entities", get_current_round(), id, i_stop);
                }
            }
        }
        if (!is_user_bot(id) &&
            (CVAR[VIPMENU_ROUND] <= get_current_round() && (!CVAR[VIPMENU_MODE] || is_nullent(get_member(id, m_rgpPlayerItems, PRIMARY_WEAPON_SLOT)))))
                pre_open_menu(id, MENU_BUY);
    }
}

public bool:_acs_check_adv_limits2(f_data[ACS_WCS_FILTER_TASK]) {
    static i_i, key_limit, limit_id, TeamName:tm_player, l_limit[ACS_WCS_ADV_LIMITS], a_filter[ACS_WCS_AVD_FILTERS];
    new a_limit[ACS_WCS_LIMITS];
    f_data[ACS_FT_ERROR][0] = f_data[ACS_FT_REASON][0] = f_data[ACS_FT_SUFFIX][0] = 0;
    if (is_valid_player(f_data[ACS_FT_ID]) && is_valid_team(f_data[ACS_FT_ID]) && TrieGetCell(gt_adv_limit, f_data[ACS_FT_NAME], key_limit) && 0 <= key_limit < ArraySize(ga_adv_limits)) {
        f_data[ACS_FT_TM_DOMINATE] = acs_get_team_dominate(f_data[ACS_FT_TM_DIFF]);
        f_data[ACS_FT_TM_PLAYER] = tm_player;
        ArrayGetArray(ga_adv_limits, key_limit, l_limit);
        if ((TrieGetCell(gt_weapon_limit, f_data[ACS_FT_NAME], key_limit) && 0 <= key_limit < ArraySize(ga_weapon_limit)))
            ArrayGetArray(ga_weapon_limit, key_limit, a_limit);
        f_data[ACS_FT_HANDED_PLAYER] = a_limit[HANDED_PLAYER][f_data[ACS_FT_ID]];
        f_data[ACS_FT_HANDED_TEAM] = a_limit[HANDED_TEAM][any:tm_player - 1];
        f_data[ACS_FT_HANDED_TOTAL] = a_limit[HANDED_TOTAL];
        //acs_client_print(f_data[ACS_FT_ID], ACS_SHOW_DEBUG, "AVD_LIMIT2: key = %s, key_limit = %d, player = %d, team = %d, total = %d", f_data[ACS_FT_NAME], key_limit, f_data[ACS_FT_HANDED_PLAYER], f_data[ACS_FT_HANDED_TEAM], f_data[ACS_FT_HANDED_TOTAL]);
        for (i_i = 0; i_i < l_limit[WCS_LIMIT_COUNT]; i_i++) {
            limit_id = l_limit[WCS_LIMIT_ID][i_i];
            ArrayGetArray(Array:ga_filters[WCS_ADV_LIMITS], limit_id, a_filter);
            //acs_client_print(f_data[ACS_FT_ID], ACS_SHOW_DEBUG, "ADV_LIMIT2: name = %s, limit_players = %d, limit_team = %d, limit_total = %d", a_filter[FILTER_NAME], a_filter[FILTER_LIMIT], a_filter[FILTER_LIMIT_TEAM], a_filter[FILTER_LIMIT_TOTAL]);
            if (acs_check_filter_row(a_filter, f_data))
                continue;
            formatex(_SC(f_data[ACS_FT_SUFFIX]), a_filter[FILTER_NAME]);
            if (strlen(f_data[ACS_FT_REASON]) > 2)
                format(_SC(f_data[ACS_FT_REASON]), "%s", f_data[ACS_FT_REASON][2]);
            return true;
        }
    }
    return false;
}

public bool:acs_check_filter_row(a_filter[ACS_WCS_AVD_FILTERS], f_data[ACS_WCS_FILTER_TASK]) {
    static i_exp, i_reason, a_timer[ACS_TIMER_DATA];
    i_reason = 0;
    //acs_client_print(f_data[ACS_FT_ID], ACS_SHOW_DEBUG, "check_filter(): name = %s", a_filter[FILTER_NAME]);
    //acs_client_print(f_data[ACS_FT_ID], ACS_SHOW_DEBUG, "check_filter(): filter_type = %d, type = %d", a_filter[FILTER_TYPE], f_data[ACS_FT_TYPE]);
    if (a_filter[FILTER_TYPE] && !(a_filter[FILTER_TYPE] & f_data[ACS_FT_TYPE]))
        return true;
    //acs_client_print(f_data[ACS_FT_ID], ACS_SHOW_DEBUG, "check_filter(): filter_flag = %d, flag = %d", a_filter[FILTER_ACCESS_FLAG], get_user_flags(f_data[ACS_FT_ID]));
    if (a_filter[FILTER_ACCESS_FLAG] && !check_flags(a_filter[FILTER_ACCESS_FLAG], get_user_flags(f_data[ACS_FT_ID])))
        return true;
    if (a_filter[FILTER_MAPS][0] && containi(a_filter[FILTER_MAPS], gs_mapname) == -1)
        return true;
    //acs_client_print(f_data[ACS_FT_ID], ACS_SHOW_DEBUG, "check_filter(): filter_round = %d, round = %d, is_located = %d", a_filter[FILTER_ALLOW_ROUNDS], get_current_round(), is_interval_located(a_filter[FILTER_ALLOW_ROUNDS], pack_interval(fmt("%d", get_current_round()))));
    if (_SFF(a_filter[FILTER_ALLOW_ROUNDS]) && !is_interval_located(a_filter[FILTER_ALLOW_ROUNDS], pack_interval(fmt("%d", get_current_round()))))
        return true;
    //acs_client_print(f_data[ACS_FT_ID], ACS_SHOW_DEBUG, "check_filter(): filter_time = %d, time = %s", a_filter[FILTER_TIME], fmt_date("%H:%M"));
    if (_SFF2(a_filter[FILTER_TIME]) && !is_interval_located(a_filter[FILTER_TIME], pack_interval(fmt_date("%H:%M"))))
        return true;
    //acs_client_print(f_data[ACS_FT_ID], ACS_SHOW_DEBUG, "check_filter(): filter_players_count = %d, players_count = %d", a_filter[FILTER_PLAYERS_COUNT], get_playersnum());
    if (_SFF(a_filter[FILTER_PLAYERS_COUNT]) && !is_interval_located(a_filter[FILTER_PLAYERS_COUNT], pack_interval(fmt("%d", get_playersnum()))))
        return true;
    //acs_client_print(f_data[ACS_FT_ID], ACS_SHOW_DEBUG, "check_filter(): filter_exp = %d", a_filter[FILTER_EXP]);
    if ((i_exp = floatround(acs_get_player_exp(f_data[ACS_FT_ID]))) >= 0
        && _SFF(a_filter[FILTER_EXP]) && !is_interval_located(a_filter[FILTER_EXP], pack_interval(fmt("%d", i_exp))))
        return true;
    //acs_client_print(f_data[ACS_FT_ID], ACS_SHOW_DEBUG, "check_filter(): filter_domination = %d, diff = %d", a_filter[FILTER_DOMINATION], f_data[ACS_FT_TM_DIFF]);
    if (_SFF(a_filter[FILTER_DOMINATION]) && (f_data[ACS_FT_TM_DOMINATE] != f_data[ACS_FT_TM_PLAYER] || !is_interval_located(a_filter[FILTER_DOMINATION], pack_interval(fmt("%d", f_data[ACS_FT_TM_DIFF])))))
        return true;
    if (!f_data[ACS_FT_GIVE_ITEMS]) {
        //acs_client_print(f_data[ACS_FT_ID], ACS_SHOW_DEBUG, "ADV_LIMIT: limit_handed_player = %d, handed_player = %d", a_filter[FILTER_LIMIT], f_data[ACS_FT_HANDED_PLAYER]);
        if (!(_SFF3(a_filter[FILTER_LIMIT]) && a_filter[FILTER_LIMIT] <= f_data[ACS_FT_HANDED_PLAYER])) {
            //acs_client_print(f_data[ACS_FT_ID], ACS_SHOW_DEBUG, "ADV_LIMIT: limit_handed_team = %d, handed_team = %d", a_filter[FILTER_LIMIT_TEAM], f_data[ACS_FT_HANDED_TEAM]);
            if (!(_SFF3(a_filter[FILTER_LIMIT_TEAM]) && a_filter[FILTER_LIMIT_TEAM] <= f_data[ACS_FT_HANDED_TEAM])) {
                //acs_client_print(f_data[ACS_FT_ID], ACS_SHOW_DEBUG, "ADV_LIMIT: limit_handed_player = %d, handed_player = %d", a_filter[FILTER_LIMIT_TOTAL], f_data[ACS_FT_HANDED_TOTAL]);
                if (!(_SFF3(a_filter[FILTER_LIMIT_TOTAL]) && a_filter[FILTER_LIMIT_TOTAL] <= f_data[ACS_FT_HANDED_TOTAL]))
                    return true;
                else if (a_filter[FILTER_LIMIT_TOTAL] > 0)
                    formatex(_SC(f_data[ACS_FT_ERROR]), "%L", f_data[ACS_FT_ID], "WP_LIMIT_TOTAL", _DII("WP_LIMIT", a_filter[FILTER_LIMIT_TOTAL]));
            } else if (a_filter[FILTER_LIMIT_TEAM] > 0)
                formatex(_SC(f_data[ACS_FT_ERROR]), "%L", f_data[ACS_FT_ID], "WP_LIMIT_TEAM", _DII("WP_LIMIT", a_filter[FILTER_LIMIT_TEAM]));
        } else if (a_filter[FILTER_LIMIT] > 0)
            formatex(_SC(f_data[ACS_FT_ERROR]), "%L", f_data[ACS_FT_ID], "WP_LIMIT_PLAYER", _DII("WP_LIMIT", a_filter[FILTER_LIMIT]));
        if (a_filter[FILTER_LIMIT] < 0 || a_filter[FILTER_LIMIT_TEAM] < 0 || a_filter[FILTER_LIMIT_TOTAL] < 0)
            formatex(_SC(f_data[ACS_FT_ERROR]), "%L", f_data[ACS_FT_ID], "WP_LIMIT_BLOCKED");
        f_data[ACS_FT_SHOW_ERROR] = !(a_filter[FILTER_LIMIT] < -1 || a_filter[FILTER_LIMIT_TEAM] < -1 || a_filter[FILTER_LIMIT_TOTAL] < -1);
    }
    copy(_SC(f_data[ACS_FT_ITEMS]), a_filter[FILTER_ITEMS]);
    copy(_SC(f_data[ACS_FT_CL_CMDS]), a_filter[FILTER_CL_CMDS]);
    copy(_SC(f_data[ACS_FT_SV_CMDS]), a_filter[FILTER_SV_CMDS]);
    copy(_SC(f_data[ACS_FT_NATIVE]), a_filter[FILTER_NATIVE]);
    //acs_client_print(f_data[ACS_FT_ID], ACS_SHOW_DEBUG, "check_filter(): filter_delay = %f", a_filter[FILTER_DELAY]);
    if (a_filter[FILTER_DELAY] > 0.0) {
        //acs_client_print(f_data[ACS_FT_ID], ACS_SHOW_DEBUG, "check_filter(): make task");
        if (a_filter[FILTER_ITEMS][0]) {
            //log_acs("SET_TASK: id = %d, task_id = %d, name = %s, items = %s", id, i_i, t_data[TASK_NAME], t_data[TASK_ITEMS]);
            set_task(a_filter[FILTER_DELAY], "acs_process_filter", TASK_PROCESS + f_data[ACS_FT_ID], _SS(f_data));
        } else {
            if (!task_exists(TASK_PROCESS)) {
                set_task(a_filter[FILTER_DELAY], "acs_process_filter", TASK_PROCESS, _SS(f_data));
            }
            if (!task_exists(TASK_TIMER)) {
                //acs_client_print(f_data[ACS_FT_ID], ACS_SHOW_DEBUG, "check_filter(): make timer = %f", a_filter[FILTER_DELAY]);
                //log_acs("SET_TASK_TIMER: id = %d, task_id = %d, name = %s, items = %s", id, i_i, t_data[TASK_NAME], t_data[TASK_ITEMS]);
                a_timer[TIMER_VALUE] = a_filter[FILTER_DELAY];
                a_timer[TIMER_ID] = TASK_TIMER + f_data[ACS_FT_INDEX];
                task_show_timer(a_timer);
                //set_task(1.0, "task_show_timer", TASK_TIMER, _SS(a_timer), "a", floatround(a_filter[FILTER_DELAY], floatround_ceil));
            }
        }
    } else {
        //acs_client_print(f_data[ACS_FT_ID], ACS_SHOW_DEBUG, "check_filter(): id = %d, process items = %s", f_data[ACS_FT_ID], f_data[ACS_FT_ITEMS]);
        acs_process_filter(f_data);                
    }
    return false;
}

public bool:acs_check_filter(f_data[ACS_WCS_FILTER_TASK]) {
    static i_i, TeamName:tm_player, a_filter[ACS_WCS_AVD_FILTERS];
    if (is_valid_player(f_data[ACS_FT_ID]) && is_valid_team(f_data[ACS_FT_ID]) && 0 <= f_data[ACS_FT_FILTER] < ACS_WCS_ADV_FILTER_TYPES) {
        //acs_client_print(f_data[ACS_FT_ID], ACS_SHOW_DEBUG, "check_filter(): ga_filters[ %d ] = %d", f_data[ACS_FT_FILTER], ArraySize(ga_filters[f_data[ACS_FT_FILTER]]));
        f_data[ACS_FT_TM_DOMINATE] = acs_get_team_dominate(f_data[ACS_FT_TM_DIFF]);
        f_data[ACS_FT_TM_PLAYER] = tm_player;
        for (i_i = 0; i_i < ArraySize(ga_filters[f_data[ACS_FT_FILTER]]); i_i++) {            
            ArrayGetArray(ga_filters[f_data[ACS_FT_FILTER]], i_i, a_filter);
            f_data[ACS_FT_INDEX] = i_i;
            if (acs_check_filter_row(a_filter, f_data))
                continue;
            if (!f_data[ACS_FT_GIVE_ITEMS])
                return true;
        }
    }
    return false;
}

public acs_process_filter(const f_data[ACS_WCS_FILTER_TASK]) {
    //acs_client_print(f_data[ACS_FT_ID], ACS_SHOW_DEBUG, "process_filter(): items = %s, cl_cmds = %s, sv_cmds = %s, cl_native = %s", f_data[ACS_FT_ITEMS], f_data[ACS_FT_CL_CMDS], f_data[ACS_FT_SV_CMDS], f_data[ACS_FT_NATIVE]);
    if (is_valid_player(f_data[ACS_FT_ID])) {
        if (f_data[ACS_FT_CL_CMDS][0])
            client_cmd(f_data[ACS_FT_ID], f_data[ACS_FT_CL_CMDS][0]);
        if (f_data[ACS_FT_SV_CMDS][0])
            server_cmd(f_data[ACS_FT_SV_CMDS][0]);
        if (f_data[ACS_FT_NATIVE][0])
            acs_exec_native(f_data[ACS_FT_ID], f_data[ACS_FT_NATIVE]);
        if (f_data[ACS_FT_GIVE_ITEMS] && f_data[ACS_FT_ITEMS][0])
            acs_give_items(f_data[ACS_FT_ID], f_data[ACS_FT_ITEMS]);
    }
}

public CBasePlayer_ResetMaxSpeed_Post(const id) {
    static Float:f_speed, i_weapon;
    if (is_valid_player(id)) {
        if (gi_add_speed[id][SPEED_VALUE]) {
            f_speed = gi_add_speed[id][SPEED_RELATIVE] ? get_user_maxspeed(id) + float(gi_add_speed[id][SPEED_VALUE]) : float(gi_add_speed[id][SPEED_VALUE]);
            f_speed = floatclamp(f_speed, 0.0, float(CVAR[MAX_SPEED]));
            if (f_speed > get_cvar_float("sv_maxspeed")) {
                set_cvar_float("sv_maxspeed", f_speed);
            }
            set_user_maxspeed(id, f_speed);
        } else if (!is_nullent((i_weapon = get_member(id, m_pActiveItem))) && get_ms(i_weapon) > 0.0 && get_user_maxspeed(id) != get_ms(i_weapon)) {
            //acs_client_print(id, ACS_SHOW_DEBUG, "user_maxspeed = %f, var_maxspeed = %f, sv_maxspeed = %f", get_user_maxspeed(id), get_ms(i_weapon), get_cvar_float("sv_maxspeed"));
            if (get_ms(i_weapon) > get_cvar_float("sv_maxspeed")) {
                set_cvar_float("sv_maxspeed", get_ms(i_weapon));
            }
            set_user_maxspeed(id, get_ms(i_weapon));
        }
    }
}

public CBasePlayer_HasRestrictItem_Pre(const id, const ItemID:item, const ItemRestType:type) {
    static s_class_name[ACS_MAX_NAME_LENGTH];
    if (is_valid_player(id) && 0 <= any:item <= ITEM_NVG) {
        switch (item) {
            case ITEM_SHIELDGUN: copy(_SC(s_class_name), "weapon_shield");
            case ITEM_NVG: copy(_SC(s_class_name), "weapon_nvg");
            default: get_weaponname(any:item, _SC(s_class_name));
        }
        //acs_client_print(id, ACS_SHOW_DEBUG, "[WCS] HasRestrictItem_Pre(), item = %d, type = %d, classname = %s", item, (1 << any:type), s_class_name);
        if (acs_show_adv_limits_error(id, (1 << any:type), s_class_name, acs_get_weapon_name(id, s_class_name))) {
            SetHookChainReturn(ATYPE_BOOL, true);
            return HC_SUPERCEDE;
        }
    }
    return HC_CONTINUE;
}

public Touch_Pre(entity, id) {
    static i_key, i_owner_userid, item, s_key[ACS_MAX_NAME_LENGTH], a_weapon[ACS_WCS];
    if (is_valid_player(id) && !is_nullent(entity)) {
        if (!is_nullent((item = get_wb(entity))) && is_custom_weapon(item) && 0 <= (i_key = get_wk(item) - WCS_IMPULSE_OFFSET) < ArraySize(ga_weapon_data)) {
            ArrayGetArray(ga_weapon_data, i_key, a_weapon);
            formatex(_SC(s_key), "%d", i_key);
            if (acs_show_adv_limits_error(id, any:ITEM_TYPE_TOUCHED + 1, s_key, acs_get_weapon_name(id, s_key)))
                return HAM_SUPERCEDE;
        }
        if(CVAR[PICKUP_ACCESS_TYPE] &&
            !(!pickup_blocked(entity, id) || (TrieGetCell(gt_weapon_owner, fmt("%d", get_wb(entity)), i_owner_userid) && i_owner_userid == get_user_userid(id)))) {
            if(gf_touch_time[id] < get_gametime()) {
                acs_client_print(id, ACS_SHOW_NO_ACCESS, "%L", id, "CHAT_NO_ACCESS");
                gf_touch_time[id] = get_gametime() + 3.0;
            }
            return HAM_SUPERCEDE;
        }
    }
    return HAM_IGNORED;
}

public CSGameRules_CanHavePlayerItem_Pre(const id, const item) {
    /*
    ITEM_TYPE_BUYING,	// when a player buying items
    ITEM_TYPE_TOUCHED,	// when the player touches with a weaponbox or armoury_entity
    ITEM_TYPE_EQUIPPED	// when an entity game_player_equip gives item to player or default item's on player spawn
    */
    static i_key, s_key[ACS_MAX_NAME_LENGTH], a_weapon[ACS_WCS];
    if (is_valid_player(id) && !is_nullent(item)) {
        get_entvar(item, var_classname, _SC(s_key));
        //acs_client_print(id, ACS_SHOW_DEBUG, "[WCS] CanHavePlayerItem_Pre(), item = %d, key = %s, is_custom = %d, wk = %d, classname = %s", item, s_key, is_custom_weapon(item), get_wk(item) - WCS_IMPULSE_OFFSET, a_weapon[WCS_WEAPON_REFERENCE]);
        if (is_custom_weapon(item) && 0 <= (i_key = get_wk(item) - WCS_IMPULSE_OFFSET) < ArraySize(ga_weapon_data)) {
            ArrayGetArray(ga_weapon_data, i_key, a_weapon);
            formatex(_SC(s_key), "%d", i_key);
        } else
            i_key = -1;
        //acs_client_print(id, ACS_SHOW_DEBUG, "[WCS] CanHavePlayerItem_Pre(): id = %d, item = %d, name = %s, clcmds = %s", id, item, a_weapon[WCS_NAME_ITEM], a_weapon[WCS_CL_CMDS]);
        if (acs_show_adv_limits_error(id, any:ITEM_TYPE_BUYING + 1, s_key, acs_get_weapon_name(id, s_key), true)) {
            //set_entvar(item, var_owner, 0);
            //log_acs("BLOCK ITEM = %d, id = %d", item, id);
            SetHookChainReturn(ATYPE_INTEGER, 0);
            return HC_SUPERCEDE;
        }
        acs_add_weapon_limit(id, s_key, SELF_ITEM_ADD);
        if (i_key >= 0) {
            acs_add_weapon_limit(id, a_weapon[WCS_WEAPON_REFERENCE], SELF_ITEM_ADD);
            acs_add_weapon_limit(id, ACS_WEAPON_ALL_KEY, SELF_ITEM_ADD);
        }
    }  
    return HC_CONTINUE;
}

public task_show_timer(a_timer[ACS_TIMER_DATA]) {
    static i_timer, i_timer_id;
    //strtok(data, _SC(s_timer), _SC(s_timer_id), '#', 0);
    if (a_timer[TIMER_ID] != i_timer_id) {
        i_timer = floatround(a_timer[TIMER_VALUE], floatround_ceil);
        i_timer_id = a_timer[TIMER_ID];
    }
    if (i_timer > 0) {
        set_hudmessage(_DC(0), -1.0, 0.08, 0, 0.0, 2.0, 0.1, 0.2); //30, 177, 199,
        ShowSyncHudMsg(0, gh_hudsync[0/*i_timer_id % sizeof(gh_hudsync)*/], "%L", 0, fmt("ACS_WCSTIMER_%d", i_timer_id), i_timer); //
        set_task(1.0, "task_show_timer", TASK_TIMER, _SS(a_timer));
        i_timer--;
    } else {
        i_timer_id = -1;
        if (task_exists(TASK_TIMER))
            remove_task(TASK_TIMER);
    }
}

public task_acs_process_task(const data[]) {
    static s_param_1[2 * ACS_MAX_BUFFER_SIZE], s_param_2[2 * ACS_MAX_BUFFER_SIZE]; 
    static s_id[ACS_MAX_INT_STR_LENGTH / 4], s_items[ACS_MAX_BUFFER_SIZE];
    static s_cl_cmds[ACS_MAX_BUFFER_SIZE], s_sv_cmds[ACS_MAX_BUFFER_SIZE], s_cl_native[ACS_MAX_BUFFER_SIZE];
    //acs_client_print(0, ACS_SHOW_DEBUG, "task_data = %s", data);
    strtok(data, _SC(s_param_1), _SC(s_param_2), '@', 0);
    //acs_client_print(0, ACS_SHOW_DEBUG, "s_param_1 = %s, s_param_2 = %s", s_param_1, s_param_2);
    strtok(s_param_1, _SC(s_id), _SC(s_items), '#', 0);
    strtok(s_param_2, _SC(s_cl_cmds), _SC(s_param_2), '#', 0);
    strtok(s_param_2, _SC(s_sv_cmds), _SC(s_cl_native), '#', 0);
    acs_process_task(str_to_num(s_id), s_items, s_cl_cmds, s_sv_cmds, s_cl_native);
}

public acs_process_task(const id, const items[], const cl_cmds[], const sv_cmds[], const cl_native[]) {
    static s_value[ACS_MAX_NAME_ML_LENGTH], s_tmp[ACS_MAX_BUFFER_SIZE];
    //acs_client_print(id, ACS_SHOW_DEBUG, "process_task(): id = %d, items = %s, cl_cmds = %s, sv_cmds = %s, cl_native = %s", id, items, cl_cmds, sv_cmds, cl_native);
    if (!is_valid_player(id))
        return;
    if (cl_cmds[0])
        client_cmd(id, cl_cmds);
    if (sv_cmds[0])
        server_cmd(sv_cmds);
    if (cl_native[0])
        acs_exec_native(id, cl_native);
    copy(_SC(s_tmp), items);
    do {
        strtok(s_tmp, _SC(s_value), _SC(s_tmp), ',', 0);
        acs_give_item(id, s_value);
    } while (s_tmp[0]);
}

stock bool:acs_show_adv_limits_error(const id, const type, const key[], const weapon_name[], const bool:check_reference = false) {
    static bool:b_result;
    new f_data[ACS_WCS_FILTER_TASK];
    if (is_valid_player(id)) {
        f_data[ACS_FT_ID] = id;
        f_data[ACS_FT_TYPE] = type;
        f_data[ACS_FT_FILTER] = WCS_ADV_LIMITS;
        f_data[ACS_FT_GIVE_ITEMS] = false;
        copy(_SC(f_data[ACS_FT_NAME]), key);
        if ((b_result = acs_check_adv_limits2(f_data, check_reference)) && f_data[ACS_FT_SHOW_ERROR]) {
            acs_client_print(id, ACS_SHOW_NO_ACCESS2, "%L", id, "CHAT_NO_ACCESS_LIMIT", weapon_name, f_data[ACS_FT_ERROR], ""); //a_params[ALP_SUFFIX][0] ? fmt(" (%s)", a_params[ALP_SUFFIX]) : "");
            acs_client_print(id, ACS_SHOW_NO_ACCESS2, "%L", id, "CHAT_NO_ACCESS_LIMIT_REASON", f_data[ACS_FT_REASON]);
        }
    }
    return b_result;
}

stock bool:acs_check_adv_limits2(f_data[ACS_WCS_FILTER_TASK], const bool:check_reference = false) {
    static i_key, a_weapon[ACS_WCS];
    if (!is_valid_player(f_data[ACS_FT_ID]))
        return false;
    //acs_client_print(f_data[ACS_FT_ID], ACS_SHOW_DEBUG, "ACS_ADV_LIMIT: id = %d, key = %s, type = %d", f_data[ACS_FT_ID], f_data[ACS_FT_NAME], f_data[ACS_FT_TYPE]);
    if (is_str_num(f_data[ACS_FT_NAME]) && 0 <= (i_key = str_to_num(f_data[ACS_FT_NAME])) < ArraySize(ga_weapon_data)) {
        ArrayGetArray(ga_weapon_data, i_key, a_weapon);
        copy(_SC(f_data[ACS_FT_NAME]), a_weapon[WCS_CL_CMDS]);
        //acs_client_print(f_data[ACS_FT_ID], ACS_SHOW_DEBUG, "WCS_CL_CMDS = %s, type = %d", a_weapon[WCS_CL_CMDS], f_data[ACS_FT_TYPE]);
        if (_acs_check_adv_limits2(f_data))
            return true;
        copy(_SC(f_data[ACS_FT_NAME]), a_weapon[WCS_WEAPON_REFERENCE]);        
        //acs_client_print(f_data[ACS_FT_ID], ACS_SHOW_DEBUG, "WCS_CL_CMDS = %s, type = %d", a_weapon[WCS_WEAPON_REFERENCE], f_data[ACS_FT_TYPE]);
        if (check_reference && _acs_check_adv_limits2(f_data))
            return true;
        copy(_SC(f_data[ACS_FT_NAME]), ACS_WEAPON_ALL_KEY);    
        if (_acs_check_adv_limits2(f_data))
            return true;
    } else if (_acs_check_adv_limits2(f_data))
        return true;
    return false;
}

public cmd_menu(id) {
    if (is_valid_player(id) && is_user_alive(id) && !is_user_bot(id) && CVAR[VIPMENU_ROUND] <= get_current_round())
        pre_open_menu(id, MENU_BUY);
    return PLUGIN_HANDLED;
}

public cmd_wcstest(id) {
    static i_i, i_j;
    if (!is_entity_max_count()) {
        for (i_i = 1; i_i <= MAX_PLAYERS; i_i++)
            for (i_j = 0; i_j < 5; i_j++)
                if (is_valid_player(i_i) && is_user_alive(i_i)) {
                    acs_give_weapon(i_i, 10, CMD_ADMIN);
                    pre_open_menu(i_i, MENU_BUY);
                }
    }
    return PLUGIN_HANDLED;
}

stock pre_open_menu(id, menu_type, const params[] = "") {
    static i_i, i_tmp[2], h_menu, h_menu_callback, s_wp_clcmds[ACS_MAX_NAME_LENGTH], m_data[ACS_WCS_MENU];
    static s_wp_primary[ACS_MAX_NAME_LENGTH], s_wp_secondary[ACS_MAX_NAME_LENGTH];
    static s_tmp[ACS_MAX_BUFFER_SIZE], s_value[ACS_MAX_NAME_ML_LENGTH], s_flag[ACS_MAX_FLAG_CHARS], s_step[ACS_MAX_INT_STR_LENGTH], s_items[ACS_MAX_BUFFER_SIZE];
    static s_menu_name[ACS_MAX_NAME_ML_LENGTH], s_menu_header[2 * ACS_MAX_BUFFER_SIZE], s_server_name[ACS_MAX_NAME_ML_LENGTH];
    player_menu_info(id, i_tmp[0], i_tmp[1]);
    //log_acs("[WCS] MENU: id = %d, old_menu = %d, new_menu = %d", id, i_tmp[0], i_tmp[1]);
    if (i_tmp[1] >= 0)
        return;
    //log_acs("[WCS] MENU: id = %d, type = %d, data = %s", id, menu_type, params);
    // wp_clcmds, flag, step, items, selected_name
    strtok(params, _SC(s_wp_clcmds), _SC(s_tmp), '#', 0);
    strtok(s_wp_clcmds, _SC(s_wp_primary), _SC(s_wp_secondary), '@', 0);
    strtok(s_tmp, _SC(s_flag), _SC(s_tmp), '#', 0);
    strtok(s_tmp, _SC(s_step), _SC(s_tmp), '#', 0);
    strtok(s_tmp, _SC(s_items), _SC(s_tmp), '#', 0);
    formatex(_SC(s_menu_name), "%L", id, fmt("ACS_WCSMENU_%d_NAME", menu_type));
    switch (menu_type) {
        case MENU_BUY: {
            if (CVAR[SERVER_NAME][0])
                copy(_SC(s_server_name), CVAR[SERVER_NAME]);
            else
                get_user_name(0, _SC(s_server_name));
            formatex(_SC(s_menu_header), "%L", id, fmt("ACS_WCSMENU_%d_HEADER", menu_type), s_menu_name, s_server_name, id, ga_gamecms_data[id][GAMECMS_TIMELEFT_TEXT]);
            //log_acs("[WCS] MENU HEADER = %s, text = %s", s_menu_header, ga_gamecms_data[id][GAMECMS_TIMELEFT_TEXT]);
        }
        case MENU_BUY_1:
            formatex(_SC(s_menu_header), "%L", id, fmt("ACS_WCSMENU_%d_HEADER", menu_type), s_menu_name, s_tmp);
    }
    h_menu = menu_create(s_menu_header, "acs_menu_cmd");
    h_menu_callback = menu_makecallback("acs_menu_callback");
    menu_setprop(h_menu, MPROP_EXITNAME, fmt("%L", id, "ACS_WCSMENU_EXITNAME"));
    menu_setprop(h_menu, MPROP_BACKNAME, fmt("%L", id, "ACS_WCSMENU_BACKNAME"));
    menu_setprop(h_menu, MPROP_NEXTNAME, fmt("%L", id, "ACS_WCSMENU_NEXTNAME"));
    switch (menu_type) {
        case MENU_BUY:
            for (i_i = 0; i_i < ArraySize(ga_menu_data); i_i++) {
                ArrayGetArray(ga_menu_data, i_i, m_data);
                // wp_clcmds, flag, allow_round, cost, step, items, clcmds, plugin:native
                menu_additem(
                    h_menu, m_data[MENU_NAME], fmt("%s#%d#%d#%d#%d#%s#%s#%s", /*s_wp_clcmds*/ "" /*m_data[MENU_ITEMS]*/, m_data[MENU_ACCESS_FLAGS], m_data[MENU_ALLOW_ROUND], 0, menu_type, m_data[MENU_ITEMS], m_data[MENU_CLCMDS], m_data[MENU_NATIVE]), 0, h_menu_callback);
            }
        case MENU_BUY_1: {
            new a_weapon[ACS_WCS], s_data[ACS_WCS_SECONDARY], s_primary[ACS_MAX_BUFFER_SIZE / 2], s_secondary[ACS_MAX_BUFFER_SIZE / 2];
            new Array:a_list = ArrayCreate(ACS_WCS_SECONDARY);
            new i_sec_index, s_sec_index[ACS_MAX_INT_STR_LENGTH / 2], s_authid[MAX_AUTHID_LENGTH], s_md5[33], s_key[ACS_MAX_BUFFER_SIZE];
            hash_string(s_items, Hash_Md5, _SC(s_md5));
            get_user_authid(id, _SC(s_authid));
            formatex(_SC(s_key), "%s_%s", s_authid, s_md5);
            strtok(s_items, _SC(s_primary), _SC(s_secondary), '@', 0);
            do {
                strtok(s_secondary, _SC(s_data[WCS_SEC_CL_CMDS]), _SC(s_secondary), ',', 0);
                ArrayPushArray(a_list, s_data);
            } while (s_secondary[0]);
            if (ArraySize(a_list) > 0) {
                if (!(acs_offline(ACS_NVLT_CORE, ACS_OFFLINE_GET, s_key, _SC(s_sec_index)) && is_str_num(s_sec_index) && 0 <= (i_sec_index = str_to_num(s_sec_index)) < ArraySize(a_list))) {
                    i_sec_index = 0;
                    acs_offline(ACS_NVLT_CORE, ACS_OFFLINE_SET, s_key, fmt("%d", i_sec_index));
                }
                ArrayGetArray(a_list, i_sec_index, s_data);
                do {
                    strtok(s_primary, _SC(s_value), _SC(s_primary), ',', 0);
                    if (s_value[0] && TrieGetCell(gt_weapon_clcmd, s_value, i_i) && 0 <= i_i < ArraySize(ga_weapon_data)) {
                        ArrayGetArray(ga_weapon_data, i_i, a_weapon);
                        // wp_clcmds, flag, allow_round, cost, step, selected_item
                        menu_additem(h_menu, a_weapon[WCS_NAME_ITEM], fmt("%s@%s#%d#%d#%d#%d#%d", a_weapon[WCS_CL_CMDS], s_data[WCS_SEC_CL_CMDS], a_weapon[WCS_ACCESS_FLAGS], 0, a_weapon[WCS_COST], menu_type, i_i), 0, h_menu_callback);
                    }
                } while (s_primary[0]);
                menu_addblank2(h_menu);
                //menu_addtext(h_menu, "Выберите пистолет:", 0);
                if (s_data[WCS_SEC_CL_CMDS][0])
                    // wp_clcmds, flag, allow_round, cost, step, selected_item
                    menu_additem(h_menu, fmt("%L", id, "ACS_WCSMENU_CHOOSE_SECONDARY", acs_get_weapon_name(id, s_data[WCS_SEC_CL_CMDS])), fmt("%s#%d#%d#%d#%d#%s", s_data[WCS_SEC_CL_CMDS], 0, 0, 0, menu_type + 1, s_items), 0, h_menu_callback);
            }
        }
    }
    menu_set_timeout(id, h_menu, CVAR[VIPMENU_TIMEOUT] ? CVAR[VIPMENU_TIMEOUT] : -1);
    menu_display(id, h_menu);
    //log_acs("[MENU] DISPLAY: id = %d, menu = %d", id, h_menu);
}

public acs_menu_cmd(id, menu, item) {
    static i_access, i_callback, s_item_name[ACS_MAX_NAME_ML_LENGTH], s_tmp[ACS_MAX_BUFFER_SIZE];//, i_plugin_id, func_id;
    static i_step, s_wp_clcmds[ACS_MAX_NAME_ML_LENGTH], s_flag[ACS_MAX_FLAG_CHARS], s_round[ACS_MAX_INT_STR_LENGTH], s_step[ACS_MAX_INT_STR_LENGTH], s_cost[ACS_MAX_INT_STR_LENGTH];
    static s_wp_primary[ACS_MAX_NAME_LENGTH], s_wp_secondary[ACS_MAX_NAME_LENGTH];
    static s_items[ACS_MAX_BUFFER_SIZE], s_clcmds[ACS_MAX_NAME_ML_LENGTH];
    if (is_valid_player(id) && item != MENU_EXIT) {
        if (is_user_alive(id)) {
            menu_item_getinfo(menu, item, i_access, _SC(s_tmp), _SC(s_item_name), i_callback);
            //log_acs("[WCS] MENU_CMD: id = %d, menu = %d, item = %d, data = %s", id, menu, item, s_tmp);
            // wp_clcmds, flag, allow_round, cost, step, items, clcmds, plugin:native
            strtok(s_tmp, _SC(s_wp_clcmds), _SC(s_tmp), '#', 0);
            strtok(s_wp_clcmds, _SC(s_wp_primary), _SC(s_wp_secondary), '@', 0);
            strtok(s_tmp, _SC(s_flag), _SC(s_tmp), '#', 0);
            strtok(s_tmp, _SC(s_round), _SC(s_tmp), '#', 0);
            strtok(s_tmp, _SC(s_cost), _SC(s_tmp), '#', 0);
            strtok(s_tmp, _SC(s_step), _SC(s_tmp), '#', 0);
            strtok(s_tmp, _SC(s_items), _SC(s_tmp), '#', 0);
            strtok(s_tmp, _SC(s_clcmds), _SC(s_tmp), '#', 0);
            //strtok(s_tmp, _SC(s_plugin), _SC(s_native), ':', 0);
            if (is_str_num(s_step)) { 
                switch ((i_step = str_to_num(s_step))) {
                    case MENU_BUY: {
                        if (s_clcmds[0])
                            client_cmd(id, s_clcmds);
                        if (s_tmp[0])
                            acs_exec_native(id, s_tmp);
                        if (s_items[0])
                            // wp_clcmds, flag, step, items, selected_name
                            pre_open_menu(id, i_step + 1, fmt("%s#%s#%d#%s#%s", s_wp_clcmds, s_flag, i_step + 1, s_items, s_item_name));
                    }
                    case MENU_BUY_1: {
                        if (is_str_num(s_items))
                            acs_give_weapon(id, str_to_num(s_items), CMD_PLAYER);
                        if (s_wp_secondary[0])
                            acs_give_item(id, s_wp_secondary);
                    }
                    case MENU_BUY_2 : {
                        new s_authid[MAX_AUTHID_LENGTH], s_md5[33], s_key[ACS_MAX_BUFFER_SIZE], i_key_index;
                        hash_string(s_items, Hash_Md5, _SC(s_md5));
                        get_user_authid(id, _SC(s_authid));
                        formatex(_SC(s_key), "%s_%s", s_authid, s_md5);
                        if (acs_offline(ACS_NVLT_CORE, ACS_OFFLINE_GET, s_key, s_tmp, charsmax(s_tmp)) && is_str_num(s_tmp))
                            i_key_index = str_to_num(s_tmp) + 1;
                        acs_offline(ACS_NVLT_CORE, ACS_OFFLINE_SET, s_key, fmt("%d", i_key_index));
                        //menu_display(id, menu);
                        //acs_client_print(id, ACS_SHOW_DEBUG, "S_KEY = %s, INDEX = %d", s_key, i_key_index);
                        pre_open_menu(id, i_step - 1, fmt("%s#%s#%d#%s#%s", s_wp_clcmds, s_flag, i_step - 1, s_items, s_item_name));
                    }
                }
            }
        } else
            acs_client_print(id, ACS_SHOW_NO_ACCESS, "%L", id, "CHAT_ONLY_FOR_ALIVE");
    }
    menu_destroy(menu);
    //log_acs("[MENU] DESTROY: id = %d, h_menu = %d", id, menu);
}

public acs_menu_callback(id, menu, item) {
    static i_cost, ITEM_SUFFIX[ACS_MAX_NAME_LENGTH];
    static i_access, i_callback, i_round, s_item_name[ACS_MAX_NAME_ML_LENGTH], s_tmp[ACS_MAX_BUFFER_SIZE];
    static s_wp_clcmds[ACS_MAX_NAME_ML_LENGTH], s_flag[ACS_MAX_INT_STR_LENGTH], s_round[ACS_MAX_INT_STR_LENGTH], s_cost[ACS_MAX_INT_STR_LENGTH], s_step[ACS_MAX_INT_STR_LENGTH], s_items[ACS_MAX_BUFFER_SIZE], s_clcmds[ACS_MAX_NAME_ML_LENGTH];
    static s_wp_primary[ACS_MAX_NAME_LENGTH], s_wp_secondary[ACS_MAX_NAME_LENGTH], s_wp_name[ACS_MAX_NAME_LENGTH];
    new f_data[ACS_WCS_FILTER_TASK];//a_params[ACS_WCS_ADV_LIMIT_PARAMS];
    if (!is_valid_player(id))
        return ITEM_DISABLED;
    menu_item_getinfo(menu, item, i_access, _SC(s_tmp), _SC(s_item_name), i_callback);
    copy(_SC(s_wp_name), s_item_name);
    //log_acs("[WCS] MENU_CALLBACK: id = %d, menu = %d, item = %d, data = %s", id, menu, item, s_tmp);
    formatex(_SC(ITEM_SUFFIX), "%L", id, "ACS_WCSMENU_ITEM_SUFFIX");
    // wp_clcmds, flag, allow_round, cost, step, items, clcmds, plugin:native
    strtok(s_tmp, _SC(s_wp_clcmds), _SC(s_tmp), '#', 0);
    strtok(s_wp_clcmds, _SC(s_wp_primary), _SC(s_wp_secondary), '@', 0);
    strtok(s_tmp, _SC(s_flag), _SC(s_tmp), '#', 0);
    strtok(s_tmp, _SC(s_round), _SC(s_tmp), '#', 0);
    strtok(s_tmp, _SC(s_cost), _SC(s_tmp), '#', 0);
    strtok(s_tmp, _SC(s_step), _SC(s_tmp), '#', 0);
    strtok(s_tmp, _SC(s_items), _SC(s_tmp), '#', 0);
    strtok(s_tmp, _SC(s_clcmds), _SC(s_tmp), '#', 0);
    if (!(s_flag[0] == '0' || (get_user_flags(id) & str_to_num(s_flag))))
        return ITEM_DISABLED;
    if (is_str_num(s_items)) {
        f_data[ACS_FT_ID] = id;
        f_data[ACS_FT_TYPE] = any:ITEM_TYPE_BUYING + 1;
        copy(_SC(f_data[ACS_FT_NAME]), s_items);
        if (acs_check_adv_limits2(f_data, true)) {
            if (strfind(s_item_name, ITEM_SUFFIX) < 0) {
                format(_SC(s_item_name), "%s %s", s_item_name, fmt("%L", id, "ACS_WCSMENU_ITEM_SUFFIX_FORMAT", ITEM_SUFFIX, f_data[ACS_FT_SUFFIX]));
                menu_item_setname(menu, item, s_item_name);
            }
            return ITEM_DISABLED;
        }
    }
    if (is_str_num(s_round) && (i_round = str_to_num(s_round)) > get_current_round()) {
        if (strfind(s_item_name, ITEM_SUFFIX) < 0) {
            format(_SC(s_item_name), "%s %s", s_item_name, fmt("%L", id, "ACS_WCSMENU_ITEM_SUFFIX_FORMAT", ITEM_SUFFIX, fmt("%L", id, "ACS_WCSMENU_ITEM_ROUND_FORMAT", unpack_interval(i_round, INTERVAL_ROUNDS))));
            menu_item_setname(menu, item, s_item_name);
        }
        return ITEM_DISABLED;
    }
    if ((i_cost = str_to_num(s_cost))) {
        if (strfind(s_item_name, ITEM_SUFFIX) < 0) {
            format(_SC(s_item_name), "%s %s", s_item_name, fmt("%L", id, "ACS_WCSMENU_ITEM_SUFFIX_FORMAT", ITEM_SUFFIX, i_cost > 0 ? fmt("$%d", i_cost) : fmt("%d ANEW", abs(i_cost))));
            menu_item_setname(menu, item, s_item_name);
        }
        if (i_cost > 0) {
            if (rg_get_user_money(id) < i_cost)
                return ITEM_DISABLED;
        } else {
            //acs_client_print(id, ACS_SHOW_DEBUG, "MENU_CALLBACK: BONUS = %d, EXP = %f", acs_get_player_bonus(id), acs_get_player_exp(id));
            if (acs_get_player_bonus(id) < abs(i_cost))
                return ITEM_DISABLED;
        }
    }
    return ITEM_ENABLED;
}

public acs_cfg(const filename[]) {
    static h_file, i_i, i_limit_id, s_key[ACS_MAX_NAME_LENGTH];
    static s_path[MAX_RESOURCE_PATH_LENGTH], s_tmp[8 * ACS_MAX_BUFFER_SIZE];
    new a_weapon[ACS_WCS], m_data[ACS_WCS_MENU], l_limit[ACS_WCS_ADV_LIMITS], s_line[ACS_WCS_CFG];
    new a_filters[ACS_WCS_AVD_FILTERS];
    get_configsdir(_SC(s_path));
    format(s_path, charsmax(s_path), "%s/%s", s_path, filename);
    if ((h_file = fopen(s_path, "rt"))) {
        ga_menu_data = ArrayCreate(ACS_WCS_MENU, WCS_MAX_MENU_LINE);
        ga_weapon_data = ArrayCreate(ACS_WCS, WCS_MAX_WEAPONS);
        ga_weapon_limit = ArrayCreate(ACS_WCS_LIMITS, WCS_MAX_LIMITS);
        ga_adv_limits = ArrayCreate(ACS_WCS_ADV_LIMITS, WCS_MAX_ADV_LIMITS);
        ga_filters[WCS_ADV_LIMITS] = ArrayCreate(ACS_WCS_AVD_FILTERS, WCS_MAX_FILTERS);
        ga_filters[WCS_ADV_TASKS] = ArrayCreate(ACS_WCS_AVD_FILTERS, WCS_MAX_FILTERS);
        ga_filters[WCS_ADV_EVENTS] = ArrayCreate(ACS_WCS_AVD_FILTERS, WCS_MAX_FILTERS);
        gt_weapon_owner = TrieCreate();
        gt_weapon_limit = TrieCreate();
        gt_adv_limit = TrieCreate(); // => ga_adv_limits(key) => [N] => [arr_limit]
        gt_weapon_clcmd = TrieCreate();
        gt_weapon_recoil = TrieCreate();
        while (!feof(h_file) && gi_weapon_count < WCS_MAX_WEAPONS) {
            fgets(h_file, s_tmp, charsmax(s_tmp));
            replace(s_tmp, charsmax(s_tmp), "^n", "");
            trim(s_tmp);
            if (is_event_line(s_tmp)) {
                parse(s_tmp[2],
                    _SC(a_filters[FILTER_NAME]), _SC(s_line[cfg_type]), _SC(s_line[cfg_access_flag]), _SC(a_filters[FILTER_MAPS]), _SC(s_line[cfg_allow_round]),
                    _SC(s_line[cfg_time]), _SC(s_line[cfg_players_count]), _SC(s_line[cfg_exp]), _SC(s_line[cfg_domination]),
                    _SC(a_filters[FILTER_ITEMS]), _SC(a_filters[FILTER_CL_CMDS]), _SC(a_filters[FILTER_SV_CMDS]), _SC(a_filters[FILTER_NATIVE])
                );
                log_acs("[WCS] EVENT_NAME = %s, EVENT_TYPE = %s, EVENT_ACCESS_FLAG = %s, EVENT_MAPS = %s,  EVENT_ALLOW_ROUND = %s, EVENT_TIME = %s, EVENT_PLAYERS_COUNT = %s, EVENT_EXP = %s, EVENT_DOMINATION = %s, EVENT_ITEMS = %s, EVENT_CL_CMDS = %s, EVENT_SV_CMDS = %s, EVENT_NATIVE = %s",
                    a_filters[TASK_NAME], s_line[cfg_type], s_line[cfg_access_flag], a_filters[FILTER_MAPS], s_line[cfg_allow_round], s_line[cfg_time], s_line[cfg_players_count], s_line[cfg_exp], s_line[cfg_domination], a_filters[TASK_ITEMS], a_filters[TASK_CL_CMDS], a_filters[TASK_SV_CMDS], a_filters[TASK_NATIVE]
                );
                a_filters[FILTER_TYPE] = str_to_num(s_line[cfg_type]);
                a_filters[FILTER_ACCESS_FLAG] = acs_read_flags(s_line[cfg_access_flag]);
                a_filters[FILTER_ALLOW_ROUNDS] = pack_interval(s_line[cfg_allow_round]);
                a_filters[FILTER_DELAY] = 0.0;
                a_filters[FILTER_TIME] = pack_interval(s_line[cfg_time]);
                a_filters[FILTER_PLAYERS_COUNT] = pack_interval(s_line[cfg_players_count]);
                a_filters[FILTER_EXP] = pack_interval(s_line[cfg_exp]);
                a_filters[FILTER_DOMINATION] = pack_interval(s_line[cfg_domination]);
                a_filters[FILTER_LIMIT] = a_filters[FILTER_LIMIT_TEAM] = a_filters[FILTER_LIMIT_TOTAL] = 0;
                ArrayPushArray(Array:ga_filters[WCS_ADV_EVENTS], a_filters);
                continue;
            }
            if (is_task_line(s_tmp)) {
                parse(s_tmp[2],
                    _SC(a_filters[FILTER_NAME]), _SC(s_line[cfg_type]), _SC(s_line[cfg_access_flag]), _SC(a_filters[FILTER_MAPS]), _SC(s_line[cfg_allow_round]), _SC(s_line[cfg_delay]),
                    _SC(s_line[cfg_time]), _SC(s_line[cfg_players_count]), _SC(s_line[cfg_exp]), _SC(s_line[cfg_domination]), _SC(a_filters[FILTER_ITEMS]),
                    _SC(a_filters[FILTER_CL_CMDS]), _SC(a_filters[FILTER_SV_CMDS]), _SC(a_filters[FILTER_NATIVE])
                );
                log_acs("[WCS] TASK_NAME = %s, TASK_TYPE = %s, TASK_ACCESS_FLAG = %s, TASK_MAPS = %s, TASK_ALLOW_ROUND = %s, TASK_DELAY = %d, TASK_TIME = %s, TASK_PLAYERS_COUNT = %s, TASK_EXP = %s, TASK_DOMINATION = %s, TASK_ITEMS = %s, TASK_CL_CMDS = %s, TASK_SV_CMDS = %s, TASK_NATIVE = %s",
                    a_filters[FILTER_NAME], s_line[cfg_type], s_line[cfg_access_flag], a_filters[FILTER_MAPS], s_line[cfg_allow_round], s_line[cfg_delay], s_line[cfg_time], s_line[cfg_players_count], s_line[cfg_exp], s_line[cfg_domination], a_filters[FILTER_ITEMS], a_filters[FILTER_CL_CMDS], a_filters[FILTER_SV_CMDS], a_filters[FILTER_NATIVE]
                );
                a_filters[FILTER_TYPE] = str_to_num(s_line[cfg_type]);
                a_filters[FILTER_ACCESS_FLAG] = acs_read_flags(s_line[cfg_access_flag]);
                a_filters[FILTER_ALLOW_ROUNDS] = pack_interval(s_line[cfg_allow_round]);
                a_filters[FILTER_DELAY] = str_to_float(s_line[cfg_delay]);                
                a_filters[FILTER_TIME] = pack_interval(s_line[cfg_time]);
                a_filters[FILTER_PLAYERS_COUNT] = pack_interval(s_line[cfg_players_count]);
                a_filters[FILTER_EXP] = pack_interval(s_line[cfg_exp]);
                a_filters[FILTER_DOMINATION] = pack_interval(s_line[cfg_domination]);
                a_filters[FILTER_LIMIT] = a_filters[FILTER_LIMIT_TEAM] = a_filters[FILTER_LIMIT_TOTAL] = 0;
                ArrayPushArray(Array:ga_filters[WCS_ADV_TASKS], a_filters);
                continue;
            }
            if (is_adv_limit_line(s_tmp)) {
                parse(s_tmp[2],
                    _SC(a_filters[FILTER_NAME]), _SC(s_line[cfg_type]), _SC(s_line[cfg_access_flag]), _SC(a_filters[FILTER_MAPS]), _SC(s_line[cfg_allow_round]),
                    _SC(s_line[cfg_time]), _SC(s_line[cfg_players_count]), _SC(s_line[cfg_exp]), _SC(s_line[cfg_domination]),
                    _SC(s_line[cfg_limit]), _SC(s_line[cfg_limit_team]), _SC(s_line[cfg_limit_total]), _SC(s_line[cfg_items]),
                    _SC(a_filters[FILTER_CL_CMDS]), _SC(a_filters[FILTER_NATIVE])
                );
                log_acs("[WCS] ADV_NAME = %s, ADV_TYPE = %s, ADV_ACCESS_FLAG = %s, ADV_MAPS = %s, ADV_ALLOW_ROUND = %s, ADV_TIME = %s, ADV_PLAYERS_COUNT = %s, ADV_EXP = %s, ADV_DOMINATION = %s, ADV_LIMIT = %s, ADV_LIMIT_TEAM = %s, ADV_LIMIT_TOTAL = %s, ADV_ITEMS = %s, ADV_CL_CMDS = %s, ADV_NATIVE = %s",
                    a_filters[FILTER_NAME], s_line[cfg_type], s_line[cfg_access_flag], a_filters[FILTER_MAPS], s_line[cfg_allow_round], s_line[cfg_time], s_line[cfg_players_count], s_line[cfg_exp], s_line[cfg_domination], s_line[cfg_limit], s_line[cfg_limit_team], s_line[cfg_limit_total], s_line[cfg_items], a_filters[FILTER_CL_CMDS], a_filters[FILTER_NATIVE]
                );
                a_filters[FILTER_TYPE] = str_to_num(s_line[cfg_type]);
                a_filters[FILTER_ACCESS_FLAG] = acs_read_flags(s_line[cfg_access_flag]);
                a_filters[FILTER_ALLOW_ROUNDS] = pack_interval(s_line[cfg_allow_round]);
                a_filters[FILTER_DELAY] = 0.0;
                a_filters[FILTER_TIME] = pack_interval(s_line[cfg_time]);
                a_filters[FILTER_PLAYERS_COUNT] = pack_interval(s_line[cfg_players_count]);
                a_filters[FILTER_EXP] = pack_interval(s_line[cfg_exp]);
                a_filters[FILTER_DOMINATION] = pack_interval(s_line[cfg_domination]);
                a_filters[FILTER_LIMIT] = str_to_num(s_line[cfg_limit]);
                a_filters[FILTER_LIMIT_TEAM] = str_to_num(s_line[cfg_limit_team]);
                a_filters[FILTER_LIMIT_TOTAL] = str_to_num(s_line[cfg_limit_total]);

                i_limit_id = ArrayPushArray(Array:ga_filters[WCS_ADV_LIMITS], a_filters);
                do {
                    strtok(s_line[cfg_items], _SC(s_key), _SC(s_line[cfg_items]), ',', 0);
                    if (!s_key[0])
                        copy(_SC(s_key), ACS_WEAPON_ALL_KEY);
                    if (TrieGetCell(gt_adv_limit, s_key, i_i) && 0 <= i_i < ArraySize(ga_adv_limits)) {
                        ArrayGetArray(ga_adv_limits, i_i, l_limit);
                        if (l_limit[WCS_LIMIT_COUNT] < WCS_MAX_ADV_LIMITS) {
                            l_limit[WCS_LIMIT_ID][l_limit[WCS_LIMIT_COUNT]] = i_limit_id;
                            l_limit[WCS_LIMIT_COUNT]++;
                            ArraySetArray(ga_adv_limits, i_i, l_limit);
                        } else
                            log_acs("[WCS] MAX_ADV_LIMITS reached!");
                    } else {
                        l_limit[WCS_LIMIT_ID][0] = i_limit_id;
                        l_limit[WCS_LIMIT_COUNT] = 1;
                        TrieSetCell(gt_adv_limit, s_key, (i_i = ArrayPushArray(ga_adv_limits, l_limit)))
                    }
                    log_acs("[WCS] ADV_LIMITS [ %s ] => [%d][%d] => %s (%d)", s_key, i_i, l_limit[WCS_LIMIT_COUNT] - 1, a_filters[FILTER_NAME], l_limit[WCS_LIMIT_COUNT]);
                } while (s_line[cfg_items][0]);
                continue;
            }
            if (is_menu_line(s_tmp)) {
                parse(s_tmp[2],
                    _SC(m_data[MENU_NAME]), _SC(s_line[cfg_allow_round]), _SC(s_line[cfg_access_flag]),
                    _SC(m_data[MENU_ITEMS]), _SC(m_data[MENU_CLCMDS]), _SC(m_data[MENU_NATIVE])
                );
                log_acs("[WCS] MENU_NAME = %s, MENU_ALLOW_ROUND = %s, MENU_ACCESS_FLAG = %s, MENU_ITEMS = %s",
                    m_data[MENU_NAME], s_line[cfg_allow_round], s_line[cfg_access_flag], m_data[MENU_ITEMS]
                );
                m_data[MENU_ALLOW_ROUND] = str_to_num(s_line[cfg_allow_round]);
                m_data[MENU_ACCESS_FLAGS] = acs_read_flags(s_line[cfg_access_flag]);
                ArrayPushArray(ga_menu_data, m_data);
                continue;
            }
            if (is_comment_line(s_tmp))
                continue;
            parse(s_tmp,
                _SC(a_weapon[WCS_WEAPON_REFERENCE]), _SC(a_weapon[WCS_CL_CMDS]), _SC(a_weapon[WCS_NAME_ITEM]), _SC(s_line[cfg_cost]),
                _SC(s_line[cfg_ammo]), _SC(s_line[cfg_bp_ammo]), _SC(s_line[cfg_damage]), _SC(s_line[cfg_recoil]), _SC(a_weapon[WCS_MAXSPEED]),
                _SC(s_line[cfg_trace]), _SC(s_line[cfg_menu_add]), _SC(s_line[cfg_access_flag]), _SC(s_line[cfg_pickup_flag]),
                _SC(a_weapon[WCS_MODEL_VIEW]), _SC(a_weapon[WCS_MODEL_PLAYER]), _SC(a_weapon[WCS_MODEL_WORLD])
            );
            log_acs("[WCS] WEAPON_REFERENCE = %s, WEAPON_CLCMD = %s, WAPON_MENU_NAME = %s, WEAPON_COST = %s, WEAPON_AMMO = %s, WEAPON_BPAMMO = %s, WEAPON_DAMAGE = %s, WEAPON_RECOIL = %s, WEAPON_MAXSPEED = %s, WEAPON_TRACE = %s, WEAPON_MENU_ADD = %s, WEAPON_FLAG = %s, WEAPON_FLAG2 = %s, WEAPON_VIEW = %s, WEAPON_PLAYER = %s, WEAPON_WORLD = %s",
                a_weapon[WCS_WEAPON_REFERENCE], a_weapon[WCS_CL_CMDS], a_weapon[WCS_NAME_ITEM], s_line[cfg_cost], s_line[cfg_ammo], s_line[cfg_bp_ammo], s_line[cfg_damage], s_line[cfg_recoil], a_weapon[WCS_MAXSPEED], s_line[cfg_trace], s_line[cfg_menu_add], s_line[cfg_access_flag], s_line[cfg_pickup_flag], a_weapon[WCS_MODEL_VIEW], a_weapon[WCS_MODEL_PLAYER], a_weapon[WCS_MODEL_WORLD] 
            );
            if (a_weapon[WCS_MODEL_VIEW][0]) {
                if (!file_exists(a_weapon[WCS_MODEL_VIEW]))
                    acs_set_fail_state("[WCS] Model not found ^"%s^"", a_weapon[WCS_MODEL_VIEW]);
                else
                    precache_model(a_weapon[WCS_MODEL_VIEW]);
            }
            if (a_weapon[WCS_MODEL_PLAYER][0]) {
                if (!file_exists(a_weapon[WCS_MODEL_PLAYER]))
                    acs_set_fail_state("[WCS] Model not found ^"%s^"", a_weapon[WCS_MODEL_PLAYER]);
                else
                    precache_model(a_weapon[WCS_MODEL_PLAYER]);
            }
            if (a_weapon[WCS_MODEL_WORLD][0]) {
                if (!file_exists(a_weapon[WCS_MODEL_WORLD]))
                    acs_set_fail_state("[WCS] Model not found ^"%s^"", a_weapon[WCS_MODEL_WORLD]);
                else
                    precache_model(a_weapon[WCS_MODEL_WORLD]);
            }
            a_weapon[WCS_ACCESS_FLAGS] = acs_read_flags(s_line[cfg_access_flag]);
            a_weapon[WCS_PICKUP_FLAGS] = acs_read_flags(s_line[cfg_pickup_flag]);
            if((a_weapon[WCS_WEAPON_ID] = rg_get_weapon_info(a_weapon[WCS_WEAPON_REFERENCE], WI_ID)) == WEAPON_NONE)
                acs_set_fail_state("[WCS] Invalid weapon classname ^"%s^"", a_weapon[WCS_WEAPON_REFERENCE]);
            a_weapon[WCS_COST] = str_to_num(s_line[cfg_cost]);
            a_weapon[WCS_AMMO] = str_to_num(s_line[cfg_ammo]);
            a_weapon[WCS_BP_AMMO] = str_to_num(s_line[cfg_bp_ammo]);
            a_weapon[WCS_DAMAGE] = str_to_float(s_line[cfg_damage]);
            a_weapon[WCS_RECOIL] = s_line[cfg_recoil][0] ? str_to_float(s_line[cfg_recoil]) : 1.0;
            a_weapon[WCS_TRACE] = str_to_num(s_line[cfg_trace]);
            a_weapon[WCS_MENU_ADD] = str_to_num(s_line[cfg_menu_add]);
            TrieSetCell(gt_weapon_clcmd, a_weapon[WCS_CL_CMDS], ArrayPushArray(ga_weapon_data, a_weapon));
            TrieSetCell(gt_weapon_clcmd, WP_KEY(register_clcmd(a_weapon[WCS_CL_CMDS], "cmd_give_weapon_ex")), gi_weapon_count); 
            if (!is_recoil_module_loaded && !TrieKeyExists(gt_weapon_recoil, a_weapon[WCS_WEAPON_REFERENCE]) && a_weapon[WCS_RECOIL] < 1.0) {
                TrieSetCell(gt_weapon_recoil, a_weapon[WCS_WEAPON_REFERENCE], a_weapon[WCS_RECOIL]);
                RegisterHam(Ham_Weapon_PrimaryAttack, a_weapon[WCS_WEAPON_REFERENCE], "CBasePlayerWeapon_PrimaryAttack_Post", true);
            }
            gi_weapon_count++;
        }
        fclose(h_file);
    } else
        acs_set_fail_state("[WCS] File not found ^"%s^"", s_path);
}

public CBasePlayerWeapon_PrimaryAttack_Post(entity) {
    static i_player, Float:f_recoil, Float:fv_punch_angle[3];
    if (!is_nullent(entity) && is_custom_weapon(entity) && (f_recoil = get_wr(entity)) < 1.0 && (i_player = get_member(entity, m_pPlayer))) {
        get_entvar(i_player, var_punchangle, fv_punch_angle);
        fv_punch_angle[0] *= f_recoil;
        fv_punch_angle[1] *= f_recoil;
        fv_punch_angle[2] *= f_recoil;
        set_entvar(i_player, var_punchangle, fv_punch_angle);
    }
}

public CWeaponBox_SetModel_Pre(entity, view_model[]) {
    static i_weapon, s_world[MAX_RESOURCE_PATH_LENGTH];
    if(!is_nullent(entity) && !is_nullent((i_weapon = get_wb(entity))) && is_custom_weapon(i_weapon)) {
        get_wmw(i_weapon, s_world);
        if(s_world[0])
            SetHookChainArg(2, ATYPE_STRING, s_world);
        set_wk(entity, get_wk(i_weapon));
        set_cw(entity, get_wk(i_weapon));
        set_wr(entity, get_wr(i_weapon));
        set_wt(entity, get_wt(i_weapon));
        set_wf(entity, get_wf(i_weapon));
        set_wf2(entity, get_wf2(i_weapon));
        set_ms(entity, get_ms(i_weapon));
    }
    return HC_CONTINUE;
}

public CSGameRules_DeadPlayerWeapons_Pre(id) {
    //acs_client_print(id, ACS_SHOW_DEBUG, "round_infinite = %d", gb_round_infinite);
    if (gb_round_infinite || is_entity_max_count()) {
        SetHookChainReturn(ATYPE_INTEGER, GR_PLR_DROP_GUN_NO);
        return HC_SUPERCEDE;
    }
    return HC_CONTINUE;
}

public CBasePlayerWeapon_DefaultDeploy_Pre(entity, view_model[], weapon_model[], anim, anim_ext[], skip_local) {
    static s_view[MAX_RESOURCE_PATH_LENGTH], s_player[MAX_RESOURCE_PATH_LENGTH];
    if(!is_nullent(entity) && is_custom_weapon(entity)) {
        get_wmv(entity, s_view);
        get_wmp(entity, s_player);
        if (s_view[0] && s_player[0]) {
            SetHookChainArg(2, ATYPE_STRING, s_view);
            SetHookChainArg(3, ATYPE_STRING, s_player);
        }
    }
    return HC_CONTINUE;
}

public TraceAttack_Post(victim, killer, Float:damage, Float:v_direction[3], trace, bits_damage) {
    static i_entity, Float:vec_end_pos[3], Float:vec_origin[3];
    if (is_valid_player(killer)) { 
        i_entity = get_member(killer, m_pActiveItem);
        if(!is_nullent(i_entity) && get_member(i_entity, m_iId) != WEAPON_KNIFE && is_custom_weapon(i_entity) && get_wt(i_entity)) {
            get_tr2(trace, TR_vecEndPos, vec_end_pos);
            if(CVAR[TRACE_TYPE] && gh_lazer_beam) {	
                message_begin(MSG_BROADCAST, SVC_TEMPENTITY);
                {
                    write_byte(TE_BEAMENTPOINT);
                    write_short(killer | 0x1000);
                    engfunc(EngFunc_WriteCoord, vec_end_pos[0]);
                    engfunc(EngFunc_WriteCoord, vec_end_pos[1]);
                    engfunc(EngFunc_WriteCoord, vec_end_pos[2]);
                    write_short(gh_lazer_beam);
                    write_byte(0);
                    write_byte(0);
                    write_byte(1);
                    write_byte(10);
                    write_byte(0);
                    write_byte(255);    // R
                    write_byte(215);    // G
                    write_byte(0);      // B
                    write_byte(200);    // A
                    write_byte(255);
                }
                message_end();
            } else {
                get_entvar(killer, var_origin, vec_origin);
                message_begin(MSG_BROADCAST, SVC_TEMPENTITY);
                {
                    write_byte(TE_TRACER);
                    engfunc(EngFunc_WriteCoord, vec_origin[0]);
                    engfunc(EngFunc_WriteCoord, vec_origin[1]);
                    engfunc(EngFunc_WriteCoord, vec_origin[2]);
                    engfunc(EngFunc_WriteCoord, vec_end_pos[0]);
                    engfunc(EngFunc_WriteCoord, vec_end_pos[1]);
                    engfunc(EngFunc_WriteCoord, vec_end_pos[2]);
                }
                message_end();
            }
        }
    }
}

public cmd_give_weapon(id) {
    static i_player, i_key, a_weapon[ACS_WCS];
    static s_target[ACS_MAX_NAME_LENGTH], s_param[ACS_MAX_NAME_LENGTH];
    if (is_valid_player(id)) {
        if ((get_user_flags(id) & read_flags(CVAR[CMD_ACCESS]))) {
            read_argv(1, _SC(s_target));
            read_argv(2, _SC(s_param));
            if (s_param[0] && s_target[0] && (i_player = cmd_target(id, s_target, CMDTARGET_ALLOW_SELF)) && get_bit(gi_client_connected, i_player)) {
                if (TrieGetCell(gt_weapon_clcmd, s_param, i_key)) {
                    ArrayGetArray(ga_weapon_data, i_key, a_weapon);
                    if (a_weapon[WCS_MENU_ADD])
                        acs_give_weapon(i_player, i_key, CMD_ADMIN);
                } else
                    console_print(id, "%L", id, "CONSOLE_WEAPONS_NOTFOUND");
            } else
                console_print(id, "%L", id, "CONSOLE_USAGE");
        } else
            console_print(id, "%L", id, "CONSOLE_NO_ACCESS");
    }
    return PLUGIN_HANDLED;
}

public cmd_give_weapon_ex(id, level, cid) {
    static i_key;
    if (is_valid_player(id)) {
        if (TrieGetCell(gt_weapon_clcmd, WP_KEY(cid), i_key)) {
            //log_acs("[WCS] cid = %u, weapon_key = %s, key = %d", cid, WP_KEY(cid), i_key);
            if (get_user_flags(id) & read_flags(CVAR[CMD_ACCESS]))
                acs_give_weapon(id, i_key, CMD_PLAYER);
            else
                console_print(id, "%L", id, "CONSOLE_NO_ACCESS");
        }
    }
    return PLUGIN_HANDLED;
}

stock acs_add_weapon_limit(const id, const key[], const bool:is_item_add = false) {
    static key_limit, TeamName:tm_player;
    new a_limit[ACS_WCS_LIMITS];
    if (is_valid_player(id) && is_valid_team(id)) {
        //log_acs("weapon_limit(): key = %s", key);
        if ((TrieGetCell(gt_weapon_limit, key, key_limit) && 0 <= key_limit < ArraySize(ga_weapon_limit)))
            ArrayGetArray(ga_weapon_limit, key_limit, a_limit);
        else 
            key_limit = -1;
        if (is_item_add)
            a_limit[HANDED_PLAYER][id]++;
        a_limit[HANDED_TEAM][any:tm_player - 1]++;
        a_limit[HANDED_TOTAL]++;
        //log_acs("weapon_limit(): key = %s, key_limit = %d, handed_player = %d, handed_team = %d, handed_total = %d, is_add = %d", key, key_limit, a_limit[HANDED_PLAYER][id], a_limit[HANDED_TEAM][any:tm_player - 1], a_limit[HANDED_TOTAL], is_item_add);
        if (key_limit >= 0)
            ArraySetArray(ga_weapon_limit, key_limit, a_limit);
        else
            TrieSetCell(gt_weapon_limit, key, ArrayPushArray(ga_weapon_limit, a_limit));
    }
}

stock bool:acs_give_weapon(id, key, ACS_WCS_CMD_TYPES:cmd_type, bool:show_notification = true) {
    static a_weapon[ACS_WCS], Float:f_maxspeed;
    static i_cost, Float:f_buy_time, i_entity, Float:vec_origin[3], i_owner;
    if (is_valid_player(id) && 0 <= key <= ArraySize(ga_weapon_data)) {
        ArrayGetArray(ga_weapon_data, key, a_weapon);
        i_cost = 0;
        if (is_purchase) {
            if (a_weapon[WCS_ACCESS_FLAGS] && !(get_user_flags(id) & a_weapon[WCS_ACCESS_FLAGS])) {
                acs_client_print(id, ACS_SHOW_NO_ACCESS, "%L", id, "CHAT_NO_ACCESS");
                return false;
            }
            if(CVAR[BUYTIME]) {
                f_buy_time = (get_cvar_float("mp_buytime") * 60.0) * CVAR[BUYTIME];
                if(get_gametime() - Float:get_member_game(m_fRoundStartTime) > f_buy_time) {
                    acs_client_print(id, ACS_SHOW_BUYTIME, "%L", id, "CENTER_BUYTIME", floatround(f_buy_time));
                    return false;
                }
            }
            if (CVAR[BUYZONE]) {
                if(!rg_get_user_buyzone(id)) {
                    acs_client_print(id, ACS_SHOW_NOT_IN_BUYZONE, "%L", id, "CENTER_NOT_IN_BUYZONE");
                    return false;
                }
            }
            if (a_weapon[WCS_COST]) {
                i_cost = CVAR[DISCOUNT] > 0 ? a_weapon[WCS_COST] * (100 - CVAR[DISCOUNT]) / 100 : a_weapon[WCS_COST];
                if (i_cost > 0) {
                    if (rg_get_user_money(id) < i_cost) {
                        acs_client_print(id, ACS_SHOW_NO_MONEY, "%L", id, "CHAT_NO_MONEY");
                        acs_blink_account(id);
                        return false;
                    }
                } else {
                    if (acs_get_player_bonus(id) < abs(i_cost)) {
                        acs_client_print(id, ACS_SHOW_NO_MONEY, "%L", id, "CHAT_NO_MONEY");
                        return false;
                    }
                }
            }
        }
        if (acs_show_adv_limits_error(id, any:ITEM_TYPE_BUYING + 1, fmt("%d", key), a_weapon[WCS_NAME_ITEM], true))
            return false;
        i_entity = acs_create_entity(a_weapon[WCS_WEAPON_REFERENCE]);
        log_acs("ENT CREATE = %d, is_nullent = %d", i_entity, is_nullent(i_entity));
        if (!is_nullent((i_entity))) {
            get_entvar(id, var_origin, vec_origin);
            set_entvar(i_entity, var_origin, vec_origin);
            set_wk(i_entity, key + WCS_IMPULSE_OFFSET);
            set_cw(i_entity, key + WCS_IMPULSE_OFFSET);
            set_wmv(i_entity, a_weapon[WCS_MODEL_VIEW]);
            set_wmw(i_entity, a_weapon[WCS_MODEL_WORLD]);
            set_wmp(i_entity, a_weapon[WCS_MODEL_PLAYER]);
            set_wt(i_entity, a_weapon[WCS_TRACE]);
            set_wf(i_entity, a_weapon[WCS_ACCESS_FLAGS]);
            set_wf2(i_entity, a_weapon[WCS_PICKUP_FLAGS]);
            set_wr(i_entity, a_weapon[WCS_RECOIL]);
            if (a_weapon[WCS_MAXSPEED][0]) {
                //acs_client_print(id, ACS_SHOW_DEBUG, "[MAX_SPEED] = %s, curr_speed = %f", a_weapon[WCS_MAXSPEED], get_ms(i_entity));
                if ((f_maxspeed = a_weapon[WCS_MAXSPEED][0] == '+' || a_weapon[WCS_MAXSPEED][0] == '-' ? get_ms(i_entity) + str_to_float(a_weapon[WCS_MAXSPEED]) : str_to_float(a_weapon[WCS_MAXSPEED])) > 0.0)
                    set_ms(i_entity, f_maxspeed);
            }
            set_entvar(i_entity, var_spawnflags, get_entvar(i_entity, var_spawnflags) | SF_NORESPAWN);
            dllfunc(DLLFunc_Spawn, i_entity);
            if (!a_weapon[WCS_WEAPON_SLOT]) {
                switch (rg_get_iteminfo(i_entity, ItemInfo_iSlot)) {
                    case 1:  a_weapon[WCS_WEAPON_SLOT] = PISTOL_SLOT;
                    default: a_weapon[WCS_WEAPON_SLOT] = PRIMARY_WEAPON_SLOT;
                }
                ArraySetArray(ga_weapon_data, key, a_weapon);
            }
            if(a_weapon[WCS_WEAPON_ID] != WEAPON_KNIFE)
                acs_drop_weapons(id, a_weapon[WCS_WEAPON_SLOT]);
            else
                rg_remove_item(id, "weapon_knife");
            dllfunc(DLLFunc_Touch, i_entity, id);
            i_owner = get_entvar(i_entity, var_owner);
            //log_acs("ENT CREATE = %d, id = %d, owner = %d", i_entity, id, i_owner);
            if (i_owner == id) {
                if (f_maxspeed > get_cvar_float("sv_maxspeed"))
                    set_cvar_float("sv_maxspeed", f_maxspeed);
                TrieSetCell(gt_weapon_owner, fmt("%d", i_entity), get_user_userid(id));
                switch(a_weapon[WCS_WEAPON_ID]) {
                    case WEAPON_KNIFE: {
                        set_member(i_entity, m_Knife_flStabBaseDamage, Float: get_member(i_entity, m_Knife_flStabBaseDamage) * a_weapon[WCS_DAMAGE]);
                        set_member(i_entity, m_Knife_flSwingBaseDamage, Float: get_member(i_entity, m_Knife_flSwingBaseDamage) * a_weapon[WCS_DAMAGE]);
                        set_member(i_entity, m_Knife_flSwingBaseDamage_Fast, Float: get_member(i_entity, m_Knife_flSwingBaseDamage_Fast) * a_weapon[WCS_DAMAGE]);
                    }
                    case WEAPON_M4A1:
                        set_member(i_entity, m_M4A1_flBaseDamageSil, Float: get_member(i_entity, m_M4A1_flBaseDamageSil) * a_weapon[WCS_DAMAGE]);
                    case WEAPON_USP:
                        set_member(i_entity, m_USP_flBaseDamageSil, Float: get_member(i_entity, m_USP_flBaseDamageSil) * a_weapon[WCS_DAMAGE]);
                    case WEAPON_FAMAS:
                        set_member(i_entity, m_Famas_flBaseDamageBurst, Float: get_member(i_entity, m_Famas_flBaseDamageBurst) * a_weapon[WCS_DAMAGE]);
                }
                set_member(i_entity, m_Weapon_flBaseDamage, Float: get_member(i_entity, m_Weapon_flBaseDamage) * a_weapon[WCS_DAMAGE]);
                if (a_weapon[WCS_WEAPON_ID] != WEAPON_KNIFE) {
                    rg_set_user_ammo(id, a_weapon[WCS_WEAPON_ID], a_weapon[WCS_AMMO]);
                    rg_set_user_bpammo(id, a_weapon[WCS_WEAPON_ID], a_weapon[WCS_BP_AMMO]);
                    rg_set_iteminfo(i_entity, ItemInfo_iMaxClip, a_weapon[WCS_AMMO]);
                    rg_set_iteminfo(i_entity, ItemInfo_iMaxAmmo1, a_weapon[WCS_BP_AMMO]);
                }
                if (show_notification) {
                    if (is_purchase) {
                        if (i_cost > 0)
                            rg_add_account(id, -i_cost);
                        else
                            acs_set_player_bonus(id, clamp(i_cost + acs_get_player_bonus(id), 0));
                    }
                    acs_client_print(id, is_purchase ? ACS_SHOW_BUY : ACS_SHOW_GET, "%L", id, is_purchase ? "CHAT_WEAPON_BUY" : "CHAT_WEAPON_GET", a_weapon[WCS_NAME_ITEM]);
                }
                return true;
            } else {
                log_acs("ENT REMOVE = %d", i_entity);
                remove_entity(i_entity);
                //acs_remove_entity(i_entity, true);
                //engfunc(EngFunc_RemoveEntity, i_entity);
            }
        }
    }
    return false;
}

public acs_give_items(const id, const items[]) {
    new s_weapon[ACS_MAX_NAME_ML_LENGTH], s_tmp[ACS_MAX_BUFFER_SIZE];
    copy(_SC(s_tmp), items);
    do {
        strtok(s_tmp, _SC(s_weapon), _SC(s_tmp), ',', 0);
        acs_give_item(id, s_weapon);
    } while (s_tmp[0]);    
}

public bool:acs_give_item(const id, const weapon[]) {
    static bool:is_relative, i_count, s_count[3 * ACS_MAX_NAME_ML_LENGTH], s_item[ACS_MAX_BUFFER_SIZE];
    if (!is_valid_player(id))
        return false;
    strtok(weapon, _SC(s_item), _SC(s_count), ':', 0);
    i_count = str_to_num(s_count);
    is_relative = s_count[0] == '+' || s_count[0] == '-';
    //acs_client_print(id, ACS_SHOW_DEBUG, "process_task(): id = %d, item_value = %s, count = %d, is_relative = %d", id, _ITEM_VALUE(s_item), i_count, is_relative);
    if (!contain(_ITEM_PREFIX(s_item))) {
        if (equal(_ITEM_VALUE(s_item), "kevlar")) {
            i_count += is_relative ? rg_get_user_armor(id) : 0;
            i_count = clamp(i_count, 0, CVAR[MAX_ARMOR]);
            if (i_count > 0)
                rg_set_user_armor(id, i_count, ARMOR_KEVLAR);
        } else if (equal(_ITEM_VALUE(s_item), "vesthelm")) {
            i_count += is_relative ? rg_get_user_armor(id) : 0;
            i_count = clamp(i_count, 0, CVAR[MAX_ARMOR]);
            if (i_count > 0)
                rg_set_user_armor(id, i_count, ARMOR_VESTHELM);
        } else if (equal(_ITEM_VALUE(s_item), "defuse")) {
            rg_give_defusekit(id);
        } else if (equal(_ITEM_VALUE(s_item), "ammo")) {
            acs_set_max_ammo(id, get_member(id, m_rgpPlayerItems, PRIMARY_WEAPON_SLOT));
            acs_set_max_ammo(id, get_member(id, m_rgpPlayerItems, PISTOL_SLOT));
        } else if (equal(_ITEM_VALUE(s_item), "hp")) {
            i_count += is_relative ? get_user_health(id) : 0;
            i_count = clamp(i_count, 0, CVAR[MAX_HP]);
            if (i_count > 0)
                set_user_health(id, i_count);
        } else if (equal(_ITEM_VALUE(s_item), "money")) {
            i_count += is_relative ? rg_get_user_money(id) : 0;
            i_count = clamp(i_count, 0, CVAR[MAX_MONEY]);
            if (i_count >= 0)
                rg_add_account(id, i_count, AS_SET);
        } else if (equal(_ITEM_VALUE(s_item), "aes")) {
            acs_add_player_bonus(id, i_count);
        } else if (equal(_ITEM_VALUE(s_item), "exp")) {
            acs_add_player_exp(id, float(i_count));
        } else if (equal(_ITEM_VALUE(s_item), "damager")) {
            ga_damager[id][DMG_ENABLED] = i_count >= 0;
            ga_damager[id][DMG_THRESHOLD] = floatclamp(float(i_count), 0.0, 100.0);
        } else if (equal(_ITEM_VALUE(s_item), "speed")) {
            gi_add_speed[id][SPEED_RELATIVE] = is_relative;
            gi_add_speed[id][SPEED_VALUE] = clamp(is_relative ? i_count + gi_add_speed[id][SPEED_VALUE] : i_count, 1);
            i_count += floatround(get_user_maxspeed(id));
            i_count = clamp(i_count, 0, CVAR[MAX_SPEED]);
            //acs_client_print(id, ACS_SHOW_DEBUG, "i_count = %d, user_maxspeed = %f, speed_value = %d, sv_maxspeed = %f", i_count, get_user_maxspeed(id), gi_add_speed[id][SPEED_VALUE], get_cvar_float("sv_maxspeed"));
            //gi_add_speed[id][SPEED_RELATIVE] = is_relative;
            if (i_count > get_cvar_num("sv_maxspeed"))
                set_cvar_num("sv_maxspeed", i_count);
            set_user_maxspeed(id, float(i_count));
        } else
            return false;
    } else if (0 <= contain(_WEAPON_PREFIX(s_item)) <= 1) {
        //log_amx("WEAPON_ADD: %s, count = %d", s_item, i_count);
        i_count = clamp(i_count, 0, CVAR[MAX_AMMO]);
        switch (s_item[0]) {
            case '+': acs_give_item_ex(id, s_item[1], i_count, GT_APPEND);
            case '-': acs_give_item_ex(id, s_item[1], i_count, GT_DROP_AND_REPLACE);
            default:  acs_give_item_ex(id, s_item, i_count, GT_REPLACE);
        }
    } else
        return false;
    return true;
}

public acs_get_weapon_name(const id, const weapon[]) {
    static i_key, s_count[ACS_MAX_INT_STR_LENGTH / 2], a_weapon[ACS_WCS], s_weapon_name[ACS_MAX_NAME_ML_LENGTH];
    if (is_valid_player(id)) {
        strtok(weapon, _SC(s_weapon_name), _SC(s_count), ':', 0);
        //acs_client_print(0, ACS_SHOW_DEBUG, "GET_WEAPON_NAME = %s", s_weapon_name);
        if (!contain(s_weapon_name, "weapon_")) {
            replace_string(_SC(s_weapon_name), "weapon_", "", false);
            strtoupper(s_weapon_name);
            format(_SC(s_weapon_name), "%L", id, fmt("WP_NAME_%s", s_weapon_name));
        } else if ((TrieGetCell(gt_weapon_clcmd, s_weapon_name, i_key) || (is_str_num(weapon) && (i_key = str_to_num(weapon)) >= 0)) && 0 <= i_key < ArraySize(ga_weapon_data)) {
            ArrayGetArray(ga_weapon_data, i_key, a_weapon);
            copy(_SC(s_weapon_name), a_weapon[WCS_NAME_ITEM]);
        }
    }
    return s_weapon_name;
}

public acs_check_damager(victim, killer, Float:damage, damage_type) {
    static i_color, i_pos;
    if (is_valid_player(victim) && is_valid_player(killer) && victim != killer 
        && ga_damager[killer][DMG_ENABLED]
        && !(damage_type & DMG_BLAST)
        && damage > ga_damager[killer][DMG_THRESHOLD]
        && rg_is_player_can_takedamage(victim, killer)) {
            i_color = 0; //ga_damager[killer][DMG_TYPE] >= 0 ? random_num(0, sizeof(gv_damager_colors) - 1) : 0;
            if ((i_pos = ++ga_damager[killer][DMG_POS]) > sizeof(gv_damager_coords) - 1)
                i_pos = ga_damager[killer][DMG_POS] = 0;
            set_hudmessage(_DC(i_color), _DP(i_pos), 0, 0.0, 1.0, 0.1, 0.1);
            ShowSyncHudMsg(killer, gh_hudsync_damager[i_pos % sizeof(gh_hudsync_damager)], "%.0f", damage);
    }
}

public acs_query_handler(fail_state, Handle:query, error[], err, callback_data[], callback_data_size) {
    static id, i_timeleft, s_tmp[2 * ACS_MAX_BUFFER_SIZE], s_authid[MAX_AUTHID_LENGTH], s_date[ACS_MAX_NAME_LENGTH];
    SQL_GetQueryString(query, s_tmp, charsmax(s_tmp));
    //log_acs("[WCS] acs_query_handler: query = %s", s_tmp);
    if (fail_state == TQUERY_SUCCESS) {
        if (is_valid_player((id = str_to_num(callback_data))) && SQL_NumResults(query) > 0 && get_user_authid(id, _SC(s_authid)) && equal(s_authid, ga_gamecms_data[id][GAMECMS_AUTHID])) {
            ga_gamecms_data[id][GAMECMS_ACTIVE] = bool:SQL_ReadResult(query,  SQL_FieldNameToNum(query, "active"));
            ga_gamecms_data[id][GAMECMS_PAUSED] = bool:SQL_ReadResult(query,  SQL_FieldNameToNum(query, "pause"));
            SQL_ReadResult(query,  SQL_FieldNameToNum(query, "ending_date"), _SC(s_date));
            ga_gamecms_data[id][GAMECMS_TIMELEFT] = parse_time(s_date, "%Y-%m-%d %H:%M:%S");
            if (!ga_gamecms_data[id][GAMECMS_TIMELEFT])
                formatex(ga_gamecms_data[id][GAMECMS_TIMELEFT_TEXT], charsmax(ga_gamecms_data[][GAMECMS_TIMELEFT_TEXT]), "%L", id, "GAMECMS_TIME_NOT_EXPIRING");
            else if (ga_gamecms_data[id][GAMECMS_PAUSED])
                formatex(ga_gamecms_data[id][GAMECMS_TIMELEFT_TEXT], charsmax(ga_gamecms_data[][GAMECMS_TIMELEFT_TEXT]), "%L", id, "GAMECMS_TIME_TRACKING_STOPPED");
            else {
                i_timeleft = ga_gamecms_data[id][GAMECMS_TIMELEFT] - get_systime();
                if (i_timeleft > 0 && ga_gamecms_data[id][GAMECMS_ACTIVE]) {
                    if (i_timeleft > gi_round_time)
                        acs_declension_time(id, ga_gamecms_data[id][GAMECMS_TIMELEFT_TEXT], charsmax(ga_gamecms_data[][GAMECMS_TIMELEFT_TEXT]), i_timeleft, 1, 2);
                    else
                        formatex(ga_gamecms_data[id][GAMECMS_TIMELEFT_TEXT], charsmax(ga_gamecms_data[][GAMECMS_TIMELEFT_TEXT]), "%L", id, "GAMECMS_TIME_MAP_END_EXPIRING");
                    format(ga_gamecms_data[id][GAMECMS_TIMELEFT_TEXT], charsmax(ga_gamecms_data[][GAMECMS_TIMELEFT_TEXT]), "%L", id, "GAMECMS_TIMELEFT", ga_gamecms_data[id][GAMECMS_TIMELEFT_TEXT]);
                } else
                    formatex(ga_gamecms_data[id][GAMECMS_TIMELEFT_TEXT], charsmax(ga_gamecms_data[][GAMECMS_TIMELEFT_TEXT]), "%L", id, "GAMECMS_SERVICE_ENDED");
            }
        } else
            formatex(ga_gamecms_data[id][GAMECMS_TIMELEFT_TEXT], charsmax(ga_gamecms_data[][GAMECMS_TIMELEFT_TEXT]), "%L", id, "GAMECMS_SERVICE_NOT_FOUND");
        ga_gamecms_data[id][GAMECMS_LOADED] = true;
    } else
        log_acs("[WCS] SQL error in <%s>: %d (%s)", callback_data, err, error);
}